searchData={"items":[{"type":"module","title":"GoogleApi.Classroom.V1","doc":"API client metadata for GoogleApi.Classroom.V1.","ref":"GoogleApi.Classroom.V1.html"},{"type":"function","title":"GoogleApi.Classroom.V1.discovery_revision/0","doc":"","ref":"GoogleApi.Classroom.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Api.Courses","doc":"API calls for all endpoints tagged `Courses`.","ref":"GoogleApi.Classroom.V1.Api.Courses.html"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_create/4","doc":"Creates an alias for a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to create the alias or for access errors. * `NOT_FOUND` if the course does not exist. * `ALREADY_EXISTS` if the alias already exists. * `FAILED_PRECONDITION` if the alias requested does not make sense for the requesting user or course (for example, if a user not in a domain attempts to access a domain-scoped alias).","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course to alias. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.CourseAlias.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseAlias{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_delete/5","doc":"Deletes an alias of a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to remove the alias or for access errors. * `NOT_FOUND` if the alias does not exist. * `FAILED_PRECONDITION` if the alias requested does not make sense for the requesting user or course (for example, if a user not in a domain attempts to delete a domain-scoped alias).","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course whose alias should be deleted. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `alias` (*type:* `String.t`) - Alias to delete. This may not be the Classroom-assigned identifier.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_list/4","doc":"Returns a list of aliases for a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the course or for access errors. * `NOT_FOUND` if the course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - The identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_aliases_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_aliases_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_create/5","doc":"Creates an add-on attachment under a post. Requires the add-on to have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_create/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_create/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which to create the attachment. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. This authorization token is required for in-Classroom attachment creation but optional for partner-first attachment creation. Returns an error if not provided for partner-first attachment creation and the developer projects that created the attachment and its parent stream item do not match.\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_create/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_create/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_create/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_delete/6","doc":"Deletes an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_delete/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_delete/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_delete/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_delete/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_delete/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_get/6","doc":"Returns an add-on attachment. Requires the add-on requesting the attachment to be the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_get/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_get/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_get/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_get/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_get/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_list/5","doc":"Returns all attachments created by an add-on under the post. Requires the add-on to have active attachments on the post or have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_list/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_list/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` whose attachments should be enumerated. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of attachments to return. The service may return fewer than this value. If unspecified, at most 20 attachments will be returned. The maximum value is 20; values above 20 will be coerced to 20.\n    *   `:pageToken` (*type:* `String.t`) - A page token, received from a previous `ListAddOnAttachments` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `ListAddOnAttachments` must match the call that provided the page token.\n    *   `:postId` (*type:* `String.t`) - Optional. Identifier of the post under the course whose attachments to enumerate. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_list/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_list/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_list/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_patch/6","doc":"Updates an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_patch/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_patch/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the post under which the attachment is attached.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Required. Identifier of the post under which the attachment is attached.\n    *   `:updateMask` (*type:* `String.t`) - Required. Mask that identifies which fields on the attachment to update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `AddOnAttachment` object. If a field that does not support empty values is included in the update mask and not set in the `AddOnAttachment` object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `title` * `teacher_view_uri` * `student_view_uri` * `student_work_review_uri` * `due_date` * `due_time` * `max_points`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_patch/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_add_on_attachments_patch/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_add_on_attachments_patch/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_create/4","doc":"Creates an announcement. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course, create announcements in the requested course, share a Drive attachment, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist. * `FAILED_PRECONDITION` for the following request error: * AttachmentNotVisible","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Announcement.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Announcement{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_delete/5","doc":"Deletes an announcement. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding announcement item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding announcement, if the requesting user is not permitted to delete the requested course or for access errors. * `FAILED_PRECONDITION` if the requested announcement has already been deleted. * `NOT_FOUND` if no course exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the announcement to delete. This identifier is a Classroom-assigned identifier.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_get/5","doc":"Returns an announcement. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or announcement, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or announcement does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the announcement.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Announcement{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_get_add_on_context/5","doc":"Gets metadata for Classroom add-ons in the context of a specific post. To maintain the integrity of its own data and permissions model, an add-on should call this to validate query parameters and the requesting user's role whenever the add-on is opened in an [iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/iframes-overview). This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_get_add_on_context/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_get_add_on_context/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. The authorization token is required when neither of the following is true: * The add-on has attachments on the post. * The developer project issuing the request is the same project that created the post.\n    *   `:attachmentId` (*type:* `String.t`) - Optional. The identifier of the attachment. This field is required for all requests except when the user is in the [Attachment Discovery iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/attachment-discovery-iframe).\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_get_add_on_context/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_get_add_on_context/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnContext{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_get_add_on_context/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_list/4","doc":"Returns a list of announcements that the requester is permitted to view. Course students may only view `PUBLISHED` announcements. Course teachers and domain administrators may view all announcements. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:announcementStates` (*type:* `list(String.t)`) - Restriction on the `state` of announcements returned. If this argument is left unspecified, the default value is `PUBLISHED`.\n    *   `:orderBy` (*type:* `String.t`) - Optional sort ordering for results. A comma-separated list of fields with an optional sort direction keyword. Supported field is `updateTime`. Supported direction keywords are `asc` and `desc`. If not specified, `updateTime desc` is the default behavior. Examples: `updateTime asc`, `updateTime`\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_modify_assignees/5","doc":"Modifies assignee mode and options of an announcement. Only a teacher of the course that contains the announcement may call this method. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or course work does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_modify_assignees/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_modify_assignees/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the announcement.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_modify_assignees/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_modify_assignees/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Announcement{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_modify_assignees/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_patch/5","doc":"Updates one or more fields of an announcement. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding announcement or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `FAILED_PRECONDITION` if the requested announcement has already been deleted. * `NOT_FOUND` if the requested course or announcement does not exist","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_patch/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_patch/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the announcement.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the announcement to update. This field is required to do an update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the Announcement object. If a field that does not support empty values is included in the update mask and not set in the Announcement object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `text` * `state` * `scheduled_time`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Announcement.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_patch/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_announcements_patch/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Announcement{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_announcements_patch/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_create/5","doc":"Creates an add-on attachment under a post. Requires the add-on to have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_create/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_create/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which to create the attachment. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. This authorization token is required for in-Classroom attachment creation but optional for partner-first attachment creation. Returns an error if not provided for partner-first attachment creation and the developer projects that created the attachment and its parent stream item do not match.\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_create/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_create/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_create/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_delete/6","doc":"Deletes an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_delete/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_delete/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_delete/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_delete/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_delete/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_get/6","doc":"Returns an add-on attachment. Requires the add-on requesting the attachment to be the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_get/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_get/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_get/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_get/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_get/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_list/5","doc":"Returns all attachments created by an add-on under the post. Requires the add-on to have active attachments on the post or have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_list/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_list/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` whose attachments should be enumerated. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of attachments to return. The service may return fewer than this value. If unspecified, at most 20 attachments will be returned. The maximum value is 20; values above 20 will be coerced to 20.\n    *   `:pageToken` (*type:* `String.t`) - A page token, received from a previous `ListAddOnAttachments` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `ListAddOnAttachments` must match the call that provided the page token.\n    *   `:postId` (*type:* `String.t`) - Optional. Identifier of the post under the course whose attachments to enumerate. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_list/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_list/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_list/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_patch/6","doc":"Updates an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_patch/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_patch/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the post under which the attachment is attached.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Required. Identifier of the post under which the attachment is attached.\n    *   `:updateMask` (*type:* `String.t`) - Required. Mask that identifies which fields on the attachment to update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `AddOnAttachment` object. If a field that does not support empty values is included in the update mask and not set in the `AddOnAttachment` object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `title` * `teacher_view_uri` * `student_view_uri` * `student_work_review_uri` * `due_date` * `due_time` * `max_points`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_patch/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_patch/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_patch/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_student_submissions_get/7","doc":"Returns a student submission for an add-on attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_student_submissions_get/7"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_student_submissions_get/7","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `submission_id` (*type:* `String.t`) - Required. Identifier of the student’s submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_student_submissions_get/7-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_student_submissions_get/7","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_student_submissions_get/7-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_student_submissions_patch/7","doc":"Updates data associated with an add-on attachment submission. Requires the add-on to have been the original creator of the attachment and the attachment to have a positive `max_points` value set. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_student_submissions_patch/7"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_student_submissions_patch/7","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `submission_id` (*type:* `String.t`) - Required. Identifier of the student's submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n    *   `:updateMask` (*type:* `String.t`) - Required. Mask that identifies which fields on the attachment to update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `AddOnAttachmentStudentSubmission` object. The following fields may be specified by teachers: * `points_earned`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_student_submissions_patch/7-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_add_on_attachments_student_submissions_patch/7","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_add_on_attachments_student_submissions_patch/7-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_create/4","doc":"Creates course work. The resulting course work (and corresponding student submissions) are associated with the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to make the request. Classroom API requests to modify course work and student submissions must be made with an OAuth client ID from the associated Developer Console project. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course, create course work in the requested course, share a Drive attachment, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist. * `FAILED_PRECONDITION` for the following request error: * AttachmentNotVisible","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.CourseWork.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWork{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_delete/5","doc":"Deletes a course work. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding course work, if the requesting user is not permitted to delete the requested course or for access errors. * `FAILED_PRECONDITION` if the requested course work has already been deleted. * `NOT_FOUND` if no course exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the course work to delete. This identifier is a Classroom-assigned identifier.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_get/5","doc":"Returns course work. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or course work does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the course work.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWork{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_get_add_on_context/5","doc":"Gets metadata for Classroom add-ons in the context of a specific post. To maintain the integrity of its own data and permissions model, an add-on should call this to validate query parameters and the requesting user's role whenever the add-on is opened in an [iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/iframes-overview). This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_get_add_on_context/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_get_add_on_context/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. The authorization token is required when neither of the following is true: * The add-on has attachments on the post. * The developer project issuing the request is the same project that created the post.\n    *   `:attachmentId` (*type:* `String.t`) - Optional. The identifier of the attachment. This field is required for all requests except when the user is in the [Attachment Discovery iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/attachment-discovery-iframe).\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_get_add_on_context/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_get_add_on_context/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnContext{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_get_add_on_context/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_list/4","doc":"Returns a list of course work that the requester is permitted to view. Course students may only view `PUBLISHED` course work. Course teachers and domain administrators may view all course work. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:courseWorkStates` (*type:* `list(String.t)`) - Restriction on the work status to return. Only courseWork that matches is returned. If unspecified, items with a work status of `PUBLISHED` is returned.\n    *   `:orderBy` (*type:* `String.t`) - Optional sort ordering for results. A comma-separated list of fields with an optional sort direction keyword. Supported fields are `updateTime` and `dueDate`. Supported direction keywords are `asc` and `desc`. If not specified, `updateTime desc` is the default behavior. Examples: `dueDate asc,updateTime desc`, `updateTime,dueDate desc`\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListCourseWorkResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_create/5","doc":"Creates an add-on attachment under a post. Requires the add-on to have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_create/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_create/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which to create the attachment. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. This authorization token is required for in-Classroom attachment creation but optional for partner-first attachment creation. Returns an error if not provided for partner-first attachment creation and the developer projects that created the attachment and its parent stream item do not match.\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_create/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_create/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_create/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_delete/6","doc":"Deletes an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_delete/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_delete/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_delete/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_delete/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_delete/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_get/6","doc":"Returns an add-on attachment. Requires the add-on requesting the attachment to be the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_get/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_get/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_get/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_get/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_get/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_list/5","doc":"Returns all attachments created by an add-on under the post. Requires the add-on to have active attachments on the post or have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_list/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_list/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` whose attachments should be enumerated. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of attachments to return. The service may return fewer than this value. If unspecified, at most 20 attachments will be returned. The maximum value is 20; values above 20 will be coerced to 20.\n    *   `:pageToken` (*type:* `String.t`) - A page token, received from a previous `ListAddOnAttachments` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `ListAddOnAttachments` must match the call that provided the page token.\n    *   `:postId` (*type:* `String.t`) - Optional. Identifier of the post under the course whose attachments to enumerate. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_list/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_list/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_list/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_patch/6","doc":"Updates an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_patch/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_patch/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the post under which the attachment is attached.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:postId` (*type:* `String.t`) - Required. Identifier of the post under which the attachment is attached.\n    *   `:updateMask` (*type:* `String.t`) - Required. Mask that identifies which fields on the attachment to update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `AddOnAttachment` object. If a field that does not support empty values is included in the update mask and not set in the `AddOnAttachment` object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `title` * `teacher_view_uri` * `student_view_uri` * `student_work_review_uri` * `due_date` * `due_time` * `max_points`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_patch/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_add_on_attachments_patch/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_add_on_attachments_patch/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_create/4","doc":"Creates a course work material. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course, create course work material in the requested course, share a Drive attachment, or for access errors. * `INVALID_ARGUMENT` if the request is malformed or if more than 20 * materials are provided. * `NOT_FOUND` if the requested course does not exist. * `FAILED_PRECONDITION` for the following request error: * AttachmentNotVisible","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.CourseWorkMaterial.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWorkMaterial{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_delete/5","doc":"Deletes a course work material. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work material item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding course work material, if the requesting user is not permitted to delete the requested course or for access errors. * `FAILED_PRECONDITION` if the requested course work material has already been deleted. * `NOT_FOUND` if no course exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the course work material to delete. This identifier is a Classroom-assigned identifier.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_get/5","doc":"Returns a course work material. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work material, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or course work material does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the course work material.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWorkMaterial{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_get_add_on_context/5","doc":"Gets metadata for Classroom add-ons in the context of a specific post. To maintain the integrity of its own data and permissions model, an add-on should call this to validate query parameters and the requesting user's role whenever the add-on is opened in an [iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/iframes-overview). This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_get_add_on_context/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_get_add_on_context/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `item_id` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. The authorization token is required when neither of the following is true: * The add-on has attachments on the post. * The developer project issuing the request is the same project that created the post.\n    *   `:attachmentId` (*type:* `String.t`) - Optional. The identifier of the attachment. This field is required for all requests except when the user is in the [Attachment Discovery iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/attachment-discovery-iframe).\n    *   `:postId` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_get_add_on_context/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_get_add_on_context/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnContext{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_get_add_on_context/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_list/4","doc":"Returns a list of course work material that the requester is permitted to view. Course students may only view `PUBLISHED` course work material. Course teachers and domain administrators may view all course work material. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:courseWorkMaterialStates` (*type:* `list(String.t)`) - Restriction on the work status to return. Only course work material that matches is returned. If unspecified, items with a work status of `PUBLISHED` is returned.\n    *   `:materialDriveId` (*type:* `String.t`) - Optional filtering for course work material with at least one Drive material whose ID matches the provided string. If `material_link` is also specified, course work material must have materials matching both filters.\n    *   `:materialLink` (*type:* `String.t`) - Optional filtering for course work material with at least one link material whose URL partially matches the provided string.\n    *   `:orderBy` (*type:* `String.t`) - Optional sort ordering for results. A comma-separated list of fields with an optional sort direction keyword. Supported field is `updateTime`. Supported direction keywords are `asc` and `desc`. If not specified, `updateTime desc` is the default behavior. Examples: `updateTime asc`, `updateTime`\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_patch/5","doc":"Updates one or more fields of a course work material. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `FAILED_PRECONDITION` if the requested course work material has already been deleted. * `NOT_FOUND` if the requested course or course work material does not exist","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_patch/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_patch/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the course work material.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the course work material to update. This field is required to do an update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the course work material object. If a field that does not support empty values is included in the update mask and not set in the course work material object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `title` * `description` * `state` * `scheduled_time` * `topic_id`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.CourseWorkMaterial.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_patch/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_materials_patch/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWorkMaterial{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_materials_patch/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_modify_assignees/5","doc":"Modifies assignee mode and options of a coursework. Only a teacher of the course that contains the coursework may call this method. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or course work does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_modify_assignees/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_modify_assignees/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the coursework.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_modify_assignees/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_modify_assignees/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWork{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_modify_assignees/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_patch/5","doc":"Updates one or more fields of a course work. See google.classroom.v1.CourseWork for details of which fields may be updated and who may change them. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding course work, if the user is not permitted to make the requested modification to the student submission, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `FAILED_PRECONDITION` if the requested course work has already been deleted. * `NOT_FOUND` if the requested course or course work does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_patch/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_patch/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the course work.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the course work to update. This field is required to do an update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `CourseWork` object. If a field that does not support empty values is included in the update mask and not set in the `CourseWork` object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `title` * `description` * `state` * `due_date` * `due_time` * `max_points` * `scheduled_time` * `submission_modification_mode` * `topic_id` * `grading_period_id` Available in [V1_20240401_PREVIEW](https://developers.google.com/classroom/reference/preview) and later.\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.CourseWork.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_patch/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_patch/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.CourseWork{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_patch/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_create/5","doc":"Creates a rubric. The requesting user and course owner must have rubrics creation capabilities. For details, see [licensing requirements](https://developers.google.com/classroom/rubrics/limitations#license-requirements). For further details, see [Rubrics structure and known limitations](/classroom/rubrics/limitations). This request must be made by the Google Cloud console of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the parent course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user isn't permitted to create rubrics for course work in the requested course. * `INTERNAL` if the request has insufficient OAuth scopes. * `INVALID_ARGUMENT` if the request is malformed and for the following request error: * `RubricCriteriaInvalidFormat` * `NOT_FOUND` if the requested course or course work don't exist or the user doesn't have access to the course or course work. * `FAILED_PRECONDITION` for the following request error: * `AttachmentNotVisible`","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_create/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_create/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `course_work_id` (*type:* `String.t`) - Required. Identifier of the course work.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Rubric.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_create/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_create/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Rubric{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_create/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_delete/6","doc":"Deletes a rubric. The requesting user and course owner must have rubrics creation capabilities. For details, see [licensing requirements](https://developers.google.com/classroom/rubrics/limitations#license-requirements). This request must be made by the Google Cloud console of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding rubric. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project didn't create the corresponding rubric, or if the requesting user isn't permitted to delete the requested rubric. * `NOT_FOUND` if no rubric exists with the requested ID or the user does not have access to the course, course work, or rubric. * `INVALID_ARGUMENT` if grading has already started on the rubric.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_delete/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_delete/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `course_work_id` (*type:* `String.t`) - Required. Identifier of the course work.\n*   `id` (*type:* `String.t`) - Required. Identifier of the rubric.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_delete/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_delete/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_delete/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_get/6","doc":"Returns a rubric. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or rubric doesn't exist or if the user doesn't have access to the corresponding course work.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_get/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_get/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `course_work_id` (*type:* `String.t`) - Required. Identifier of the course work.\n*   `id` (*type:* `String.t`) - Required. Identifier of the rubric.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_get/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_get/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Rubric{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_get/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_list/5","doc":"Returns a list of rubrics that the requester is permitted to view. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or course work doesn't exist or if the user doesn't have access to the corresponding course work.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_list/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_list/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `course_work_id` (*type:* `String.t`) - Required. Identifier of the course work.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of rubrics to return. If unspecified, at most 1 rubric is returned. The maximum value is 1; values above 1 are coerced to 1.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_list/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_list/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListRubricsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_list/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_patch/6","doc":"Updates a rubric. See google.classroom.v1.Rubric for details of which fields can be updated. Rubric update capabilities are [limited](/classroom/rubrics/limitations) once grading has started. The requesting user and course owner must have rubrics creation capabilities. For details, see [licensing requirements](https://developers.google.com/classroom/rubrics/limitations#license-requirements). This request must be made by the Google Cloud console of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the parent course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project didn't create the corresponding course work, if the user isn't permitted to make the requested modification to the rubric, or for access errors. This error code is also returned if grading has already started on the rubric. * `INVALID_ARGUMENT` if the request is malformed and for the following request error: * `RubricCriteriaInvalidFormat` * `NOT_FOUND` if the requested course, course work, or rubric doesn't exist or if the user doesn't have access to the corresponding course work. * `INTERNAL` if grading has already started on the rubric.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_patch/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_patch/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `course_work_id` (*type:* `String.t`) - Required. Identifier of the course work.\n*   `id` (*type:* `String.t`) - Optional. Identifier of the rubric.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Optional. Mask that identifies which fields on the rubric to update. This field is required to do an update. The update fails if invalid fields are specified. There are multiple options to define the criteria of a rubric: the `source_spreadsheet_id` and the `criteria` list. Only one of these can be used at a time to define a rubric. The rubric `criteria` list is fully replaced by the rubric criteria specified in the update request. For example, if a criterion or level is missing from the request, it is deleted. New criteria and levels are added and an ID is assigned. Existing criteria and levels retain the previously assigned ID if the ID is specified in the request. The following fields can be specified by teachers: * `criteria` * `source_spreadsheet_id`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Rubric.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_patch/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_rubrics_patch/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Rubric{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_rubrics_patch/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_get/6","doc":"Returns a student submission. * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course, course work, or student submission or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or student submission does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_get/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_get/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the course work.\n*   `id` (*type:* `String.t`) - Identifier of the student submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_get/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_get/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.StudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_get/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_list/5","doc":"Returns a list of student submissions that the requester is permitted to view, factoring in the OAuth scopes of the request. `-` may be specified as the `course_work_id` to include student submissions for multiple course work items. Course students may only view their own work. Course teachers and domain administrators may view all student submissions. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_list/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_list/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the student work to request. This may be set to the string literal `\"-\"` to request student work for all course work in the specified course.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:late` (*type:* `String.t`) - Requested lateness value. If specified, returned student submissions are restricted by the requested value. If unspecified, submissions are returned regardless of `late` value.\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n    *   `:states` (*type:* `list(String.t)`) - Requested submission states. If specified, returned student submissions match one of the specified submission states.\n    *   `:userId` (*type:* `String.t`) - Optional argument to restrict returned student work to those owned by the student with the specified identifier. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_list/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_list/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_list/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_modify_attachments/6","doc":"Modifies attachments of student submission. Attachments may only be added to student submissions belonging to course work objects with a `workType` of `ASSIGNMENT`. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work, if the user is not permitted to modify attachments on the requested student submission, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or student submission does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_modify_attachments/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_modify_attachments/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the course work.\n*   `id` (*type:* `String.t`) - Identifier of the student submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_modify_attachments/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_modify_attachments/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.StudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_modify_attachments/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_patch/6","doc":"Updates one or more fields of a student submission. See google.classroom.v1.StudentSubmission for details of which fields may be updated and who may change them. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding course work, if the user is not permitted to make the requested modification to the student submission, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or student submission does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_patch/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_patch/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the course work.\n*   `id` (*type:* `String.t`) - Identifier of the student submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the student submission to update. This field is required to do an update. The update fails if invalid fields are specified. The following fields may be specified by teachers: * `draft_grade` * `assigned_grade`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.StudentSubmission.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_patch/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_patch/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.StudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_patch/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_reclaim/6","doc":"Reclaims a student submission on behalf of the student that owns it. Reclaiming a student submission transfers ownership of attached Drive files to the student and updates the submission state. Only the student that owns the requested student submission may call this method, and only for a student submission that has been turned in. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work, unsubmit the requested student submission, or for access errors. * `FAILED_PRECONDITION` if the student submission has not been turned in. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or student submission does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_reclaim/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_reclaim/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the course work.\n*   `id` (*type:* `String.t`) - Identifier of the student submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_reclaim/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_reclaim/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_reclaim/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_return/6","doc":"Returns a student submission. Returning a student submission transfers ownership of attached Drive files to the student and may also update the submission state. Unlike the Classroom application, returning a student submission does not set assignedGrade to the draftGrade value. Only a teacher of the course that contains the requested student submission may call this method. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work, return the requested student submission, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or student submission does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_return/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_return/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the course work.\n*   `id` (*type:* `String.t`) - Identifier of the student submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_return/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_return/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_return/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_turn_in/6","doc":"Turns in a student submission. Turning in a student submission transfers ownership of attached Drive files to the teacher and may also update the submission state. This may only be called by the student that owns the specified student submission. This request must be made by the Developer Console project of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the corresponding course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or course work, turn in the requested student submission, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course, course work, or student submission does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_turn_in/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_turn_in/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `course_work_id` (*type:* `String.t`) - Identifier of the course work.\n*   `id` (*type:* `String.t`) - Identifier of the student submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_turn_in/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_student_submissions_turn_in/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_student_submissions_turn_in/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_update_rubric/5","doc":"Updates a rubric. See google.classroom.v1.Rubric for details of which fields can be updated. Rubric update capabilities are [limited](/classroom/rubrics/limitations) once grading has started. The requesting user and course owner must have rubrics creation capabilities. For details, see [licensing requirements](https://developers.google.com/classroom/rubrics/limitations#license-requirements). This request must be made by the Google Cloud console of the [OAuth client ID](https://support.google.com/cloud/answer/6158849) used to create the parent course work item. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project didn't create the corresponding course work, if the user isn't permitted to make the requested modification to the rubric, or for access errors. This error code is also returned if grading has already started on the rubric. * `INVALID_ARGUMENT` if the request is malformed and for the following request error: * `RubricCriteriaInvalidFormat` * `NOT_FOUND` if the requested course, course work, or rubric doesn't exist or if the user doesn't have access to the corresponding course work. * `INTERNAL` if grading has already started on the rubric.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_update_rubric/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_update_rubric/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `course_work_id` (*type:* `String.t`) - Required. Identifier of the course work.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:id` (*type:* `String.t`) - Optional. Identifier of the rubric.\n    *   `:updateMask` (*type:* `String.t`) - Optional. Mask that identifies which fields on the rubric to update. This field is required to do an update. The update fails if invalid fields are specified. There are multiple options to define the criteria of a rubric: the `source_spreadsheet_id` and the `criteria` list. Only one of these can be used at a time to define a rubric. The rubric `criteria` list is fully replaced by the rubric criteria specified in the update request. For example, if a criterion or level is missing from the request, it is deleted. New criteria and levels are added and an ID is assigned. Existing criteria and levels retain the previously assigned ID if the ID is specified in the request. The following fields can be specified by teachers: * `criteria` * `source_spreadsheet_id`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Rubric.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_update_rubric/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_course_work_update_rubric/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Rubric{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_course_work_update_rubric/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_create/3","doc":"Creates a course. The user specified in `ownerId` is the owner of the created course and added as a teacher. A non-admin requesting user can only create a course with themselves as the owner. Domain admins can create courses owned by any user within their domain. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to create courses or for access errors. * `NOT_FOUND` if the primary teacher is not a valid user. * `FAILED_PRECONDITION` if the course owner's account is disabled or for the following request errors: * UserCannotOwnCourse * UserGroupsMembershipLimitReached * `ALREADY_EXISTS` if an alias was specified in the `id` and already exists.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_create/3"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_create/3","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Course.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_create/3-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_create/3","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Course{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_create/3-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_delete/4","doc":"Deletes a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to delete the requested course or for access errors. * `NOT_FOUND` if no course exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the course to delete. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_delete/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_delete/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_get/4","doc":"Returns a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or for access errors. * `NOT_FOUND` if no course exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_get/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_get/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the course to return. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_get/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Course{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_get/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_list/3","doc":"Returns a list of courses that the requesting user is permitted to view, restricted to those that match the request. Returned courses are ordered by creation time, with the most recently created coming first. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the query argument is malformed. * `NOT_FOUND` if any users specified in the query arguments do not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_list/3"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_list/3","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:courseStates` (*type:* `list(String.t)`) - Restricts returned courses to those in one of the specified states The default value is ACTIVE, ARCHIVED, PROVISIONED, DECLINED.\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n    *   `:studentId` (*type:* `String.t`) - Restricts returned courses to those having a student with the specified identifier. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n    *   `:teacherId` (*type:* `String.t`) - Restricts returned courses to those having a teacher with the specified identifier. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_list/3-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_list/3","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListCoursesResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_list/3-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_patch/4","doc":"Updates one or more fields in a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to modify the requested course or for access errors. * `NOT_FOUND` if no course exists with the requested ID. * `INVALID_ARGUMENT` if invalid fields are specified in the update mask or if no update mask is supplied. * `FAILED_PRECONDITION` for the following request errors: * CourseNotModifiable * InactiveCourseOwner * IneligibleOwner","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_patch/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_patch/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the course to update. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the course to update. This field is required to do an update. The update will fail if invalid fields are specified. The following fields are valid: * `name` * `section` * `descriptionHeading` * `description` * `room` * `courseState` * `ownerId` Note: patches to ownerId are treated as being effective immediately, but in practice it may take some time for the ownership transfer of all affected resources to complete. When set in a query parameter, this field should be specified as `updateMask=,,...`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Course.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_patch/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_patch/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Course{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_patch/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_create/5","doc":"Creates an add-on attachment under a post. Requires the add-on to have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_create/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_create/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. This authorization token is required for in-Classroom attachment creation but optional for partner-first attachment creation. Returns an error if not provided for partner-first attachment creation and the developer projects that created the attachment and its parent stream item do not match.\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which to create the attachment. This field is required, but is not marked as such while we are migrating from post_id.\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_create/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_create/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_create/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_delete/6","doc":"Deletes an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_delete/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_delete/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_delete/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_delete/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_delete/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_get/6","doc":"Returns an add-on attachment. Requires the add-on requesting the attachment to be the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_get/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_get/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_get/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_get/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_get/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_list/5","doc":"Returns all attachments created by an add-on under the post. Requires the add-on to have active attachments on the post or have permission to create new attachments on the post. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_list/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_list/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Identifier of the post under the course whose attachments to enumerate. Deprecated, use `item_id` instead.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` whose attachments should be enumerated. This field is required, but is not marked as such while we are migrating from post_id.\n    *   `:pageSize` (*type:* `integer()`) - The maximum number of attachments to return. The service may return fewer than this value. If unspecified, at most 20 attachments will be returned. The maximum value is 20; values above 20 will be coerced to 20.\n    *   `:pageToken` (*type:* `String.t`) - A page token, received from a previous `ListAddOnAttachments` call. Provide this to retrieve the subsequent page. When paginating, all other parameters provided to `ListAddOnAttachments` must match the call that provided the page token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_list/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_list/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_list/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_patch/6","doc":"Updates an add-on attachment. Requires the add-on to have been the original creator of the attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_patch/6"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_patch/6","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Required. Identifier of the post under which the attachment is attached.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:itemId` (*type:* `String.t`) - Identifier of the post under which the attachment is attached.\n    *   `:updateMask` (*type:* `String.t`) - Required. Mask that identifies which fields on the attachment to update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `AddOnAttachment` object. If a field that does not support empty values is included in the update mask and not set in the `AddOnAttachment` object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified by teachers: * `title` * `teacher_view_uri` * `student_view_uri` * `student_work_review_uri` * `due_date` * `due_time` * `max_points`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachment.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_patch/6-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_patch/6","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachment{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_patch/6-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_student_submissions_get/7","doc":"Returns a student submission for an add-on attachment. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_student_submissions_get/7"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_student_submissions_get/7","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `submission_id` (*type:* `String.t`) - Required. Identifier of the student’s submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_student_submissions_get/7-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_student_submissions_get/7","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_student_submissions_get/7-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_student_submissions_patch/7","doc":"Updates data associated with an add-on attachment submission. Requires the add-on to have been the original creator of the attachment and the attachment to have a positive `max_points` value set. This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_student_submissions_patch/7"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_student_submissions_patch/7","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `attachment_id` (*type:* `String.t`) - Required. Identifier of the attachment.\n*   `submission_id` (*type:* `String.t`) - Required. Identifier of the student's submission.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n    *   `:updateMask` (*type:* `String.t`) - Required. Mask that identifies which fields on the attachment to update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the `AddOnAttachmentStudentSubmission` object. The following fields may be specified by teachers: * `points_earned`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_student_submissions_patch/7-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_add_on_attachments_student_submissions_patch/7","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_add_on_attachments_student_submissions_patch/7-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_get_add_on_context/5","doc":"Gets metadata for Classroom add-ons in the context of a specific post. To maintain the integrity of its own data and permissions model, an add-on should call this to validate query parameters and the requesting user's role whenever the add-on is opened in an [iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/iframes-overview). This method returns the following error codes: * `PERMISSION_DENIED` for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if one of the identified resources does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_get_add_on_context/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_get_add_on_context/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Required. Identifier of the course.\n*   `post_id` (*type:* `String.t`) - Optional. Deprecated, use `item_id` instead.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:addOnToken` (*type:* `String.t`) - Optional. Token that authorizes the request. The token is passed as a query parameter when the user is redirected from Classroom to the add-on's URL. The authorization token is required when neither of the following is true: * The add-on has attachments on the post. * The developer project issuing the request is the same project that created the post.\n    *   `:attachmentId` (*type:* `String.t`) - Optional. The identifier of the attachment. This field is required for all requests except when the user is in the [Attachment Discovery iframe](https://developers.google.com/classroom/add-ons/get-started/iframes/attachment-discovery-iframe).\n    *   `:itemId` (*type:* `String.t`) - Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. This field is required, but is not marked as such while we are migrating from post_id.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_get_add_on_context/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_posts_get_add_on_context/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.AddOnContext{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_posts_get_add_on_context/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_create/4","doc":"Adds a user as a student of a course. Domain administrators are permitted to [directly add](https://developers.google.com/classroom/guides/manage-users) users within their domain as students to courses within their domain. Students are permitted to add themselves to a course using an enrollment code. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to create students in this course or for access errors. * `NOT_FOUND` if the requested course ID does not exist. * `FAILED_PRECONDITION` if the requested user's account is disabled, for the following request errors: * CourseMemberLimitReached * CourseNotModifiable * UserGroupsMembershipLimitReached * InactiveCourseOwner * `ALREADY_EXISTS` if the user is already a student or teacher in the course.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course to create the student in. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:enrollmentCode` (*type:* `String.t`) - Enrollment code of the course to create the student in. This code is required if userId corresponds to the requesting user; it may be omitted if the requesting user has administrative permissions to create students for any user.\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Student.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Student{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_delete/5","doc":"Deletes a student of a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to delete students of this course or for access errors. * `NOT_FOUND` if no student of this course has the requested ID or if the course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `user_id` (*type:* `String.t`) - Identifier of the student to delete. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_get/5","doc":"Returns a student of a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to view students of this course or for access errors. * `NOT_FOUND` if no student of this course has the requested ID or if the course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `user_id` (*type:* `String.t`) - Identifier of the student to return. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Student{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_list/4","doc":"Returns a list of students of this course that the requester is permitted to view. This method returns the following error codes: * `NOT_FOUND` if the course does not exist. * `PERMISSION_DENIED` for access errors.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. The default is 30 if unspecified or `0`. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_students_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListStudentsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_students_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_create/4","doc":"Creates a teacher of a course. Domain administrators are permitted to [directly add](https://developers.google.com/classroom/guides/manage-users) users within their domain as teachers to courses within their domain. Non-admin users should send an Invitation instead. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to create teachers in this course or for access errors. * `NOT_FOUND` if the requested course ID does not exist. * `FAILED_PRECONDITION` if the requested user's account is disabled, for the following request errors: * CourseMemberLimitReached * CourseNotModifiable * CourseTeacherLimitReached * UserGroupsMembershipLimitReached * InactiveCourseOwner * `ALREADY_EXISTS` if the user is already a teacher or student in the course.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Teacher.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Teacher{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_delete/5","doc":"Removes the specified teacher from the specified course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to delete teachers of this course or for access errors. * `NOT_FOUND` if no teacher of this course has the requested ID or if the course does not exist. * `FAILED_PRECONDITION` if the requested ID belongs to the primary teacher of this course. * `FAILED_PRECONDITION` if the requested ID belongs to the owner of the course Drive folder. * `FAILED_PRECONDITION` if the course no longer has an active owner.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `user_id` (*type:* `String.t`) - Identifier of the teacher to delete. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_get/5","doc":"Returns a teacher of a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to view teachers of this course or for access errors. * `NOT_FOUND` if no teacher of this course has the requested ID or if the course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `user_id` (*type:* `String.t`) - Identifier of the teacher to return. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Teacher{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_list/4","doc":"Returns a list of teachers of this course that the requester is permitted to view. This method returns the following error codes: * `NOT_FOUND` if the course does not exist. * `PERMISSION_DENIED` for access errors.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. The default is 30 if unspecified or `0`. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_teachers_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListTeachersResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_teachers_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_create/4","doc":"Creates a topic. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course, create a topic in the requested course, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Topic.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Topic{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_delete/5","doc":"Deletes a topic. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not allowed to delete the requested topic or for access errors. * `FAILED_PRECONDITION` if the requested topic has already been deleted. * `NOT_FOUND` if no course or topic exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the topic to delete.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_get/5","doc":"Returns a topic. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or topic, or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or topic does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course.\n*   `id` (*type:* `String.t`) - Identifier of the topic.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Topic{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_list/4","doc":"Returns the list of topics that the requester is permitted to view. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access the requested course or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course does not exist.","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListTopicResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_patch/5","doc":"Updates one or more fields of a topic. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting developer project did not create the corresponding topic or for access errors. * `INVALID_ARGUMENT` if the request is malformed. * `NOT_FOUND` if the requested course or topic does not exist","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_patch/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_patch/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `course_id` (*type:* `String.t`) - Identifier of the course. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `id` (*type:* `String.t`) - Identifier of the topic.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the topic to update. This field is required to do an update. The update fails if invalid fields are specified. If a field supports empty values, it can be cleared by specifying it in the update mask and not in the Topic object. If a field that does not support empty values is included in the update mask and not set in the Topic object, an `INVALID_ARGUMENT` error is returned. The following fields may be specified: * `name`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Topic.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_patch/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_topics_patch/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Topic{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_topics_patch/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Courses.classroom_courses_update/4","doc":"Updates a course. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to modify the requested course or for access errors. * `NOT_FOUND` if no course exists with the requested ID. * `FAILED_PRECONDITION` for the following request errors: * CourseNotModifiable","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_update/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_update/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the course to update. This identifier can be either the Classroom-assigned identifier or an alias.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Course.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_update/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Courses.classroom_courses_update/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Course{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Courses.html#classroom_courses_update/4-returns"},{"type":"module","title":"GoogleApi.Classroom.V1.Api.Invitations","doc":"API calls for all endpoints tagged `Invitations`.","ref":"GoogleApi.Classroom.V1.Api.Invitations.html"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_accept/4","doc":"Accepts an invitation, removing it and adding the invited user to the teachers or students (as appropriate) of the specified course. Only the invited user may accept an invitation. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to accept the requested invitation or for access errors. * `FAILED_PRECONDITION` for the following request errors: * CourseMemberLimitReached * CourseNotModifiable * CourseTeacherLimitReached * UserGroupsMembershipLimitReached * `NOT_FOUND` if no invitation exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_accept/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_accept/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the invitation to accept.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_accept/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_accept/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_accept/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_create/3","doc":"Creates an invitation. Only one invitation for a user and course may exist at a time. Delete and re-create an invitation to make changes. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to create invitations for this course or for access errors. * `NOT_FOUND` if the course or the user does not exist. * `FAILED_PRECONDITION`: * if the requested user's account is disabled. * if the user already has this role or a role with greater permissions. * for the following request errors: * IneligibleOwner * `ALREADY_EXISTS` if an invitation for the specified user and course already exists.","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_create/3"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_create/3","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Invitation.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_create/3-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_create/3","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Invitation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_create/3-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_delete/4","doc":"Deletes an invitation. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to delete the requested invitation or for access errors. * `NOT_FOUND` if no invitation exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the invitation to delete.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_delete/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_delete/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_get/4","doc":"Returns an invitation. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to view the requested invitation or for access errors. * `NOT_FOUND` if no invitation exists with the requested ID.","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_get/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_get/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `id` (*type:* `String.t`) - Identifier of the invitation to return.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_get/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Invitation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_get/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_list/3","doc":"Returns a list of invitations that the requesting user is permitted to view, restricted to those that match the list request. *Note:* At least one of `user_id` or `course_id` must be supplied. Both fields can be supplied. This method returns the following error codes: * `PERMISSION_DENIED` for access errors.","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_list/3"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_list/3","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:courseId` (*type:* `String.t`) - Restricts returned invitations to those for a course with the specified identifier.\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. The default is 500 if unspecified or `0`. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n    *   `:userId` (*type:* `String.t`) - Restricts returned invitations to those for a specific user. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_list/3-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Invitations.classroom_invitations_list/3","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListInvitationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Invitations.html#classroom_invitations_list/3-returns"},{"type":"module","title":"GoogleApi.Classroom.V1.Api.Registrations","doc":"API calls for all endpoints tagged `Registrations`.","ref":"GoogleApi.Classroom.V1.Api.Registrations.html"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Registrations.classroom_registrations_create/3","doc":"Creates a `Registration`, causing Classroom to start sending notifications from the provided `feed` to the destination provided in `cloudPubSubTopic`. Returns the created `Registration`. Currently, this will be the same as the argument, but with server-assigned fields such as `expiry_time` and `id` filled in. Note that any value specified for the `expiry_time` or `id` fields will be ignored. While Classroom may validate the `cloudPubSubTopic` and return errors on a best effort basis, it is the caller's responsibility to ensure that it exists and that Classroom has permission to publish to it. This method may return the following error codes: * `PERMISSION_DENIED` if: * the authenticated user does not have permission to receive notifications from the requested field; or * the current user has not granted access to the current Cloud project with the appropriate scope for the requested feed. Note that domain-wide delegation of authority is not currently supported for this purpose. If the request has the appropriate scope, but no grant exists, a Request Errors is returned. * another access error is encountered. * `INVALID_ARGUMENT` if: * no `cloudPubsubTopic` is specified, or the specified `cloudPubsubTopic` is not valid; or * no `feed` is specified, or the specified `feed` is not valid. * `NOT_FOUND` if: * the specified `feed` cannot be located, or the requesting user does not have permission to determine whether or not it exists; or * the specified `cloudPubsubTopic` cannot be located, or Classroom has not been granted permission to publish to it.","ref":"GoogleApi.Classroom.V1.Api.Registrations.html#classroom_registrations_create/3"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Registrations.classroom_registrations_create/3","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.Registration.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Registrations.html#classroom_registrations_create/3-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Registrations.classroom_registrations_create/3","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Registration{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Registrations.html#classroom_registrations_create/3-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.Registrations.classroom_registrations_delete/4","doc":"Deletes a `Registration`, causing Classroom to stop sending notifications for that `Registration`.","ref":"GoogleApi.Classroom.V1.Api.Registrations.html#classroom_registrations_delete/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.Registrations.classroom_registrations_delete/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `registration_id` (*type:* `String.t`) - The `registration_id` of the `Registration` to be deleted.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.Registrations.html#classroom_registrations_delete/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.Registrations.classroom_registrations_delete/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.Registrations.html#classroom_registrations_delete/4-returns"},{"type":"module","title":"GoogleApi.Classroom.V1.Api.UserProfiles","doc":"API calls for all endpoints tagged `UserProfiles`.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_get/4","doc":"Returns a user profile. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to access this user profile, if no profile exists with the requested ID, or for access errors.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_get/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_get/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `user_id` (*type:* `String.t`) - Identifier of the profile to return. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_get/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_get/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.UserProfile{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_get/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_create/4","doc":"Creates a guardian invitation, and sends an email to the guardian asking them to confirm that they are the student's guardian. Once the guardian accepts the invitation, their `state` will change to `COMPLETED` and they will start receiving guardian notifications. A `Guardian` resource will also be created to represent the active guardian. The request object must have the `student_id` and `invited_email_address` fields set. Failing to set these fields, or setting any other fields in the request, will result in an error. This method returns the following error codes: * `PERMISSION_DENIED` if the current user does not have permission to manage guardians, if the guardian in question has already rejected too many requests for that student, if guardians are not enabled for the domain in question, or for other access errors. * `RESOURCE_EXHAUSTED` if the student or guardian has exceeded the guardian link limit. * `INVALID_ARGUMENT` if the guardian email address is not valid (for example, if it is too long), or if the format of the student ID provided cannot be recognized (it is not an email address, nor a `user_id` from this API). This error will also be returned if read-only fields are set, or if the `state` field is set to to a value other than `PENDING`. * `NOT_FOUND` if the student ID provided is a valid student ID, but Classroom has no record of that student. * `ALREADY_EXISTS` if there is already a pending guardian invitation for the student and `invited_email_address` provided, or if the provided `invited_email_address` matches the Google account of an existing `Guardian` for this user.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_create/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_create/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - ID of the student (in standard format)\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.GuardianInvitation.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_create/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_create/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.GuardianInvitation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_create/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_get/5","doc":"Returns a specific guardian invitation. This method returns the following error codes: * `PERMISSION_DENIED` if the requesting user is not permitted to view guardian invitations for the student identified by the `student_id`, if guardians are not enabled for the domain in question, or for other access errors. * `INVALID_ARGUMENT` if a `student_id` is specified, but its format cannot be recognized (it is not an email address, nor a `student_id` from the API, nor the literal string `me`). * `NOT_FOUND` if Classroom cannot find any record of the given student or `invitation_id`. May also be returned if the student exists, but the requesting user does not have access to see that student.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - The ID of the student whose guardian invitation is being requested.\n*   `invitation_id` (*type:* `String.t`) - The `id` field of the `GuardianInvitation` being requested.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.GuardianInvitation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_list/4","doc":"Returns a list of guardian invitations that the requesting user is permitted to view, filtered by the parameters provided. This method returns the following error codes: * `PERMISSION_DENIED` if a `student_id` is specified, and the requesting user is not permitted to view guardian invitations for that student, if `\"-\"` is specified as the `student_id` and the user is not a domain administrator, if guardians are not enabled for the domain in question, or for other access errors. * `INVALID_ARGUMENT` if a `student_id` is specified, but its format cannot be recognized (it is not an email address, nor a `student_id` from the API, nor the literal string `me`). May also be returned if an invalid `page_token` or `state` is provided. * `NOT_FOUND` if a `student_id` is specified, and its format can be recognized, but Classroom has no record of that student.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - The ID of the student whose guardian invitations are to be returned. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user * the string literal `\"-\"`, indicating that results should be returned for all students that the requesting user is permitted to view guardian invitations.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:invitedEmailAddress` (*type:* `String.t`) - If specified, only results with the specified `invited_email_address` are returned.\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n    *   `:states` (*type:* `list(String.t)`) - If specified, only results with the specified `state` values are returned. Otherwise, results with a `state` of `PENDING` are returned.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_list/4-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_patch/5","doc":"Modifies a guardian invitation. Currently, the only valid modification is to change the `state` from `PENDING` to `COMPLETE`. This has the effect of withdrawing the invitation. This method returns the following error codes: * `PERMISSION_DENIED` if the current user does not have permission to manage guardians, if guardians are not enabled for the domain in question or for other access errors. * `FAILED_PRECONDITION` if the guardian link is not in the `PENDING` state. * `INVALID_ARGUMENT` if the format of the student ID provided cannot be recognized (it is not an email address, nor a `user_id` from this API), or if the passed `GuardianInvitation` has a `state` other than `COMPLETE`, or if it modifies fields other than `state`. * `NOT_FOUND` if the student ID provided is a valid student ID, but Classroom has no record of that student, or if the `id` field does not refer to a guardian invitation known to Classroom.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_patch/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_patch/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - The ID of the student whose guardian invitation is to be modified.\n*   `invitation_id` (*type:* `String.t`) - The `id` field of the `GuardianInvitation` to be modified.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:updateMask` (*type:* `String.t`) - Mask that identifies which fields on the course to update. This field is required to do an update. The update fails if invalid fields are specified. The following fields are valid: * `state` When set in a query parameter, this field should be specified as `updateMask=,,...`\n    *   `:body` (*type:* `GoogleApi.Classroom.V1.Model.GuardianInvitation.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_patch/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardian_invitations_patch/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.GuardianInvitation{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardian_invitations_patch/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_delete/5","doc":"Deletes a guardian. The guardian will no longer receive guardian notifications and the guardian will no longer be accessible via the API. This method returns the following error codes: * `PERMISSION_DENIED` if no user that matches the provided `student_id` is visible to the requesting user, if the requesting user is not permitted to manage guardians for the student identified by the `student_id`, if guardians are not enabled for the domain in question, or for other access errors. * `INVALID_ARGUMENT` if a `student_id` is specified, but its format cannot be recognized (it is not an email address, nor a `student_id` from the API). * `NOT_FOUND` if the requesting user is permitted to modify guardians for the requested `student_id`, but no `Guardian` record exists for that student with the provided `guardian_id`.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_delete/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_delete/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - The student whose guardian is to be deleted. One of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `guardian_id` (*type:* `String.t`) - The `id` field from a `Guardian`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_delete/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_delete/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Empty{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_delete/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_get/5","doc":"Returns a specific guardian. This method returns the following error codes: * `PERMISSION_DENIED` if no user that matches the provided `student_id` is visible to the requesting user, if the requesting user is not permitted to view guardian information for the student identified by the `student_id`, if guardians are not enabled for the domain in question, or for other access errors. * `INVALID_ARGUMENT` if a `student_id` is specified, but its format cannot be recognized (it is not an email address, nor a `student_id` from the API, nor the literal string `me`). * `NOT_FOUND` if the requesting user is permitted to view guardians for the requested `student_id`, but no `Guardian` record exists for that student that matches the provided `guardian_id`.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_get/5"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_get/5","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - The student whose guardian is being requested. One of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user\n*   `guardian_id` (*type:* `String.t`) - The `id` field from a `Guardian`.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_get/5-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_get/5","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.Guardian{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_get/5-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_list/4","doc":"Returns a list of guardians that the requesting user is permitted to view, restricted to those that match the request. To list guardians for any student that the requesting user may view guardians for, use the literal character `-` for the student ID. This method returns the following error codes: * `PERMISSION_DENIED` if a `student_id` is specified, and the requesting user is not permitted to view guardian information for that student, if `\"-\"` is specified as the `student_id` and the user is not a domain administrator, if guardians are not enabled for the domain in question, if the `invited_email_address` filter is set by a user who is not a domain administrator, or for other access errors. * `INVALID_ARGUMENT` if a `student_id` is specified, but its format cannot be recognized (it is not an email address, nor a `student_id` from the API, nor the literal string `me`). May also be returned if an invalid `page_token` is provided. * `NOT_FOUND` if a `student_id` is specified, and its format can be recognized, but Classroom has no record of that student.","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_list/4"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_list/4","doc":"*   `connection` (*type:* `GoogleApi.Classroom.V1.Connection.t`) - Connection to server\n*   `student_id` (*type:* `String.t`) - Filter results by the student who the guardian is linked to. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user * the string literal `\"-\"`, indicating that results should be returned for all students that the requesting user has access to view.\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:invitedEmailAddress` (*type:* `String.t`) - Filter results by the email address that the original invitation was sent to, resulting in this guardian link. This filter can only be used by domain administrators.\n    *   `:pageSize` (*type:* `integer()`) - Maximum number of items to return. Zero or unspecified indicates that the server may assign a maximum. The server may return fewer than the specified number of results.\n    *   `:pageToken` (*type:* `String.t`) - nextPageToken value returned from a previous list call, indicating that the subsequent page of results should be returned. The list request must be otherwise identical to the one that resulted in this token.\n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_list/4-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Api.UserProfiles.classroom_user_profiles_guardians_list/4","doc":"*   `{:ok, %GoogleApi.Classroom.V1.Model.ListGuardiansResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.Classroom.V1.Api.UserProfiles.html#classroom_user_profiles_guardians_list/4-returns"},{"type":"module","title":"GoogleApi.Classroom.V1.Connection","doc":"Handle Tesla connections for GoogleApi.Classroom.V1.","ref":"GoogleApi.Classroom.V1.Connection.html"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.Classroom.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.Classroom.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.Classroom.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.Classroom.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.Classroom.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.Classroom.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.Classroom.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.Classroom.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.Classroom.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Classroom.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Classroom.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Classroom.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Classroom.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Classroom.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.Classroom.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.Classroom.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.Classroom.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyword list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.Classroom.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.Classroom.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.Classroom.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.Classroom.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.Classroom.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.Classroom.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.Classroom.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.Classroom.V1.Connection.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.AddOnAttachment","doc":"An add-on attachment on a post.","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachment.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.AddOnAttachment","doc":"*   `copyHistory` (*type:* `list(GoogleApi.Classroom.V1.Model.CopyHistory.t)`, *default:* `nil`) - Output only. Identifiers of attachments that were previous copies of this attachment. If the attachment was previously copied by virtue of its parent post being copied, this enumerates the identifiers of attachments that were its previous copies in ascending chronological order of copy.\n*   `courseId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the course.\n*   `dueDate` (*type:* `GoogleApi.Classroom.V1.Model.Date.t`, *default:* `nil`) - Date, in UTC, that work on this attachment is due. This must be specified if `due_time` is specified.\n*   `dueTime` (*type:* `GoogleApi.Classroom.V1.Model.TimeOfDay.t`, *default:* `nil`) - Time of day, in UTC, that work on this attachment is due. This must be specified if `due_date` is specified.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Immutable. Classroom-assigned identifier for this attachment, unique per post.\n*   `itemId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached. Unique per course.\n*   `maxPoints` (*type:* `float()`, *default:* `nil`) - Maximum grade for this attachment. Can only be set if `studentWorkReviewUri` is set. Set to a non-zero value to indicate that the attachment supports grade passback. If set, this must be a non-negative integer value. When set to zero, the attachment will not support grade passback.\n*   `postId` (*type:* `String.t`, *default:* `nil`) - Immutable. Deprecated, use `item_id` instead.\n*   `studentViewUri` (*type:* `GoogleApi.Classroom.V1.Model.EmbedUri.t`, *default:* `nil`) - Required. URI to show the student view of the attachment. The URI will be opened in an iframe with the `courseId`, `itemId`, `itemType`, and `attachmentId` query parameters set.\n*   `studentWorkReviewUri` (*type:* `GoogleApi.Classroom.V1.Model.EmbedUri.t`, *default:* `nil`) - URI for the teacher to see student work on the attachment, if applicable. The URI will be opened in an iframe with the `courseId`, `itemId`, `itemType`, `attachmentId`, and `submissionId` query parameters set. This is the same `submissionId` returned in the [`AddOnContext.studentContext`](//devsite.google.com/classroom/reference/rest/v1/AddOnContext#StudentContext) field when a student views the attachment. If the URI is omitted or removed, `max_points` will also be discarded.\n*   `teacherViewUri` (*type:* `GoogleApi.Classroom.V1.Model.EmbedUri.t`, *default:* `nil`) - Required. URI to show the teacher view of the attachment. The URI will be opened in an iframe with the `courseId`, `itemId`, `itemType`, and `attachmentId` query parameters set.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Required. Title of this attachment. The title must be between 1 and 1000 characters.","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachment.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.AddOnAttachment.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachment.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.AddOnAttachment.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachment.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission","doc":"Payload for grade update requests.","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission","doc":"*   `pointsEarned` (*type:* `float()`, *default:* `nil`) - Student grade on this attachment. If unset, no grade was set.\n*   `postSubmissionState` (*type:* `String.t`, *default:* `nil`) - Submission state of add-on attachment's parent post (i.e. assignment).","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.AddOnAttachmentStudentSubmission.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.AddOnContext","doc":"Attachment-relevant metadata for Classroom add-ons in the context of a specific post.","ref":"GoogleApi.Classroom.V1.Model.AddOnContext.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.AddOnContext","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the course.\n*   `itemId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached.\n*   `postId` (*type:* `String.t`, *default:* `nil`) - Immutable. Deprecated, use `item_id` instead.\n*   `studentContext` (*type:* `GoogleApi.Classroom.V1.Model.StudentContext.t`, *default:* `nil`) - Add-on context corresponding to the requesting user's role as a student. Its presence implies that the requesting user is a student in the course.\n*   `supportsStudentWork` (*type:* `boolean()`, *default:* `nil`) - Optional. Whether the post allows the teacher to see student work and passback grades.\n*   `teacherContext` (*type:* `GoogleApi.Classroom.V1.Model.TeacherContext.t`, *default:* `nil`) - Add-on context corresponding to the requesting user's role as a teacher. Its presence implies that the requesting user is a teacher in the course.","ref":"GoogleApi.Classroom.V1.Model.AddOnContext.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.AddOnContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.AddOnContext.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.AddOnContext.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.AddOnContext.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Announcement","doc":"Announcement created by a teacher for students of the course","ref":"GoogleApi.Classroom.V1.Model.Announcement.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Announcement","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - Absolute link to this announcement in the Classroom web UI. This is only populated if `state` is `PUBLISHED`. Read-only.\n*   `assigneeMode` (*type:* `String.t`, *default:* `nil`) - Assignee mode of the announcement. If unspecified, the default value is `ALL_STUDENTS`.\n*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp when this announcement was created. Read-only.\n*   `creatorUserId` (*type:* `String.t`, *default:* `nil`) - Identifier for the user that created the announcement. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Classroom-assigned identifier of this announcement, unique per course. Read-only.\n*   `individualStudentsOptions` (*type:* `GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.t`, *default:* `nil`) - Identifiers of students with access to the announcement. This field is set only if `assigneeMode` is `INDIVIDUAL_STUDENTS`. If the `assigneeMode` is `INDIVIDUAL_STUDENTS`, then only students specified in this field can see the announcement.\n*   `materials` (*type:* `list(GoogleApi.Classroom.V1.Model.Material.t)`, *default:* `nil`) - Additional materials. Announcements must have no more than 20 material items.\n*   `scheduledTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional timestamp when this announcement is scheduled to be published.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Status of this announcement. If unspecified, the default state is `DRAFT`.\n*   `text` (*type:* `String.t`, *default:* `nil`) - Description of this announcement. The text must be a valid UTF-8 string containing no more than 30,000 characters.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp of the most recent change to this announcement. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Announcement.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Announcement.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Announcement.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Announcement.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Announcement.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Assignment","doc":"Additional details for assignments.","ref":"GoogleApi.Classroom.V1.Model.Assignment.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Assignment","doc":"*   `studentWorkFolder` (*type:* `GoogleApi.Classroom.V1.Model.DriveFolder.t`, *default:* `nil`) - Drive folder where attachments from student submissions are placed. This is only populated for course teachers and administrators.","ref":"GoogleApi.Classroom.V1.Model.Assignment.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Assignment.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Assignment.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Assignment.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Assignment.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.AssignmentSubmission","doc":"Student work for an assignment.","ref":"GoogleApi.Classroom.V1.Model.AssignmentSubmission.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.AssignmentSubmission","doc":"*   `attachments` (*type:* `list(GoogleApi.Classroom.V1.Model.Attachment.t)`, *default:* `nil`) - Attachments added by the student. Drive files that correspond to materials with a share mode of STUDENT_COPY may not exist yet if the student has not accessed the assignment in Classroom. Some attachment metadata is only populated if the requesting user has permission to access it. Identifier and alternate_link fields are always available, but others (for example, title) may not be.","ref":"GoogleApi.Classroom.V1.Model.AssignmentSubmission.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.AssignmentSubmission.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.AssignmentSubmission.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.AssignmentSubmission.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.AssignmentSubmission.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Attachment","doc":"Attachment added to student assignment work. When creating attachments, setting the `form` field is not supported.","ref":"GoogleApi.Classroom.V1.Model.Attachment.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Attachment","doc":"*   `driveFile` (*type:* `GoogleApi.Classroom.V1.Model.DriveFile.t`, *default:* `nil`) - Google Drive file attachment.\n*   `form` (*type:* `GoogleApi.Classroom.V1.Model.Form.t`, *default:* `nil`) - Google Forms attachment.\n*   `link` (*type:* `GoogleApi.Classroom.V1.Model.Link.t`, *default:* `nil`) - Link attachment.\n*   `youTubeVideo` (*type:* `GoogleApi.Classroom.V1.Model.YouTubeVideo.t`, *default:* `nil`) - Youtube video attachment.","ref":"GoogleApi.Classroom.V1.Model.Attachment.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Attachment.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Attachment.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Attachment.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Attachment.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic","doc":"A reference to a Cloud Pub/Sub topic. To register for notifications, the owner of the topic must grant `classroom-notifications@system.gserviceaccount.com` the `projects.topics.publish` permission.","ref":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CloudPubsubTopic","doc":"*   `topicName` (*type:* `String.t`, *default:* `nil`) - The `name` field of a Cloud Pub/Sub [Topic](https://cloud.google.com/pubsub/docs/reference/rest/v1/projects.topics#Topic).","ref":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CloudPubsubTopic.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CopyHistory","doc":"Identifier of a previous copy of a given attachment.","ref":"GoogleApi.Classroom.V1.Model.CopyHistory.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CopyHistory","doc":"*   `attachmentId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the attachment.\n*   `courseId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the course.\n*   `itemId` (*type:* `String.t`, *default:* `nil`) - Immutable. Identifier of the `Announcement`, `CourseWork`, or `CourseWorkMaterial` under which the attachment is attached.\n*   `postId` (*type:* `String.t`, *default:* `nil`) - Immutable. Deprecated, use `item_id` instead.","ref":"GoogleApi.Classroom.V1.Model.CopyHistory.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CopyHistory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CopyHistory.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CopyHistory.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CopyHistory.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Course","doc":"A Course in Classroom.","ref":"GoogleApi.Classroom.V1.Model.Course.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Course","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - Absolute link to this course in the Classroom web UI. Read-only.\n*   `calendarId` (*type:* `String.t`, *default:* `nil`) - The Calendar ID for a calendar that all course members can see, to which Classroom adds events for course work and announcements in the course. The Calendar for a course is created asynchronously when the course is set to `CourseState.ACTIVE` for the first time (at creation time or when it is updated to `ACTIVE` through the UI or the API). The Calendar ID will not be populated until the creation process is completed. Read-only.\n*   `courseGroupEmail` (*type:* `String.t`, *default:* `nil`) - The email address of a Google group containing all members of the course. This group does not accept email and can only be used for permissions. Read-only.\n*   `courseMaterialSets` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseMaterialSet.t)`, *default:* `nil`) - Sets of materials that appear on the \"about\" page of this course. Read-only.\n*   `courseState` (*type:* `String.t`, *default:* `nil`) - State of the course. If unspecified, the default state is `PROVISIONED`.\n*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - Creation time of the course. Specifying this field in a course update mask results in an error. Read-only.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Optional description. For example, \"We'll be learning about the structure of living creatures from a combination of textbooks, guest lectures, and lab work. Expect to be excited!\" If set, this field must be a valid UTF-8 string and no longer than 30,000 characters.\n*   `descriptionHeading` (*type:* `String.t`, *default:* `nil`) - Optional heading for the description. For example, \"Welcome to 10th Grade Biology.\" If set, this field must be a valid UTF-8 string and no longer than 3600 characters.\n*   `enrollmentCode` (*type:* `String.t`, *default:* `nil`) - Enrollment code to use when joining this course. Specifying this field in a course update mask results in an error. Read-only.\n*   `gradebookSettings` (*type:* `GoogleApi.Classroom.V1.Model.GradebookSettings.t`, *default:* `nil`) - The gradebook settings that specify how a student's overall grade for the course will be calculated and who it will be displayed to. Read-only\n*   `guardiansEnabled` (*type:* `boolean()`, *default:* `nil`) - Whether or not guardian notifications are enabled for this course. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Identifier for this course assigned by Classroom. When creating a course, you may optionally set this identifier to an alias string in the request to create a corresponding alias. The `id` is still assigned by Classroom and cannot be updated after the course is created. Specifying this field in a course update mask results in an error.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the course. For example, \"10th Grade Biology\". The name is required. It must be between 1 and 750 characters and a valid UTF-8 string.\n*   `ownerId` (*type:* `String.t`, *default:* `nil`) - The identifier of the owner of a course. When specified as a parameter of a create course request, this field is required. The identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user This must be set in a create request. Admins can also specify this field in a patch course request to transfer ownership. In other contexts, it is read-only.\n*   `room` (*type:* `String.t`, *default:* `nil`) - Optional room location. For example, \"301\". If set, this field must be a valid UTF-8 string and no longer than 650 characters.\n*   `section` (*type:* `String.t`, *default:* `nil`) - Section of the course. For example, \"Period 2\". If set, this field must be a valid UTF-8 string and no longer than 2800 characters.\n*   `teacherFolder` (*type:* `GoogleApi.Classroom.V1.Model.DriveFolder.t`, *default:* `nil`) - Information about a Drive Folder that is shared with all teachers of the course. This field will only be set for teachers of the course and domain administrators. Read-only.\n*   `teacherGroupEmail` (*type:* `String.t`, *default:* `nil`) - The email address of a Google group containing all teachers of the course. This group does not accept email and can only be used for permissions. Read-only.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Time of the most recent update to this course. Specifying this field in a course update mask results in an error. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Course.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Course.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Course.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Course.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Course.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseAlias","doc":"Alternative identifier for a course. An alias uniquely identifies a course. It must be unique within one of the following scopes: * domain: A domain-scoped alias is visible to all users within the alias creator's domain and can be created only by a domain admin. A domain-scoped alias is often used when a course has an identifier external to Classroom. * project: A project-scoped alias is visible to any request from an application using the Developer Console project ID that created the alias and can be created by any project. A project-scoped alias is often used when an application has alternative identifiers. A random value can also be used to avoid duplicate courses in the event of transmission failures, as retrying a request will return `ALREADY_EXISTS` if a previous one has succeeded.","ref":"GoogleApi.Classroom.V1.Model.CourseAlias.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseAlias","doc":"*   `alias` (*type:* `String.t`, *default:* `nil`) - Alias string. The format of the string indicates the desired alias scoping. * `d:` indicates a domain-scoped alias. Example: `d:math_101` * `p:` indicates a project-scoped alias. Example: `p:abc123` This field has a maximum length of 256 characters.","ref":"GoogleApi.Classroom.V1.Model.CourseAlias.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseAlias.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseAlias.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseAlias.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseAlias.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseMaterial","doc":"A material attached to a course as part of a material set.","ref":"GoogleApi.Classroom.V1.Model.CourseMaterial.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseMaterial","doc":"*   `driveFile` (*type:* `GoogleApi.Classroom.V1.Model.DriveFile.t`, *default:* `nil`) - Google Drive file attachment.\n*   `form` (*type:* `GoogleApi.Classroom.V1.Model.Form.t`, *default:* `nil`) - Google Forms attachment.\n*   `link` (*type:* `GoogleApi.Classroom.V1.Model.Link.t`, *default:* `nil`) - Link atatchment.\n*   `youTubeVideo` (*type:* `GoogleApi.Classroom.V1.Model.YouTubeVideo.t`, *default:* `nil`) - Youtube video attachment.","ref":"GoogleApi.Classroom.V1.Model.CourseMaterial.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseMaterial.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseMaterial.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseMaterial.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseMaterial.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseMaterialSet","doc":"A set of materials that appears on the \"About\" page of the course. These materials might include a syllabus, schedule, or other background information relating to the course as a whole.","ref":"GoogleApi.Classroom.V1.Model.CourseMaterialSet.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseMaterialSet","doc":"*   `materials` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseMaterial.t)`, *default:* `nil`) - Materials attached to this set.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title for this set.","ref":"GoogleApi.Classroom.V1.Model.CourseMaterialSet.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseMaterialSet.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseMaterialSet.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseMaterialSet.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseMaterialSet.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo","doc":"Information about a `Feed` with a `feed_type` of `COURSE_ROSTER_CHANGES`.","ref":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - The `course_id` of the course to subscribe to roster changes for.","ref":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseWork","doc":"Course work created by a teacher for students of the course.","ref":"GoogleApi.Classroom.V1.Model.CourseWork.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseWork","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - Absolute link to this course work in the Classroom web UI. This is only populated if `state` is `PUBLISHED`. Read-only.\n*   `assigneeMode` (*type:* `String.t`, *default:* `nil`) - Assignee mode of the coursework. If unspecified, the default value is `ALL_STUDENTS`.\n*   `assignment` (*type:* `GoogleApi.Classroom.V1.Model.Assignment.t`, *default:* `nil`) - Assignment details. This is populated only when `work_type` is `ASSIGNMENT`. Read-only.\n*   `associatedWithDeveloper` (*type:* `boolean()`, *default:* `nil`) - Whether this course work item is associated with the Developer Console project making the request. See CreateCourseWork for more details. Read-only.\n*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp when this course work was created. Read-only.\n*   `creatorUserId` (*type:* `String.t`, *default:* `nil`) - Identifier for the user that created the coursework. Read-only.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Optional description of this course work. If set, the description must be a valid UTF-8 string containing no more than 30,000 characters.\n*   `dueDate` (*type:* `GoogleApi.Classroom.V1.Model.Date.t`, *default:* `nil`) - Optional date, in UTC, that submissions for this course work are due. This must be specified if `due_time` is specified.\n*   `dueTime` (*type:* `GoogleApi.Classroom.V1.Model.TimeOfDay.t`, *default:* `nil`) - Optional time of day, in UTC, that submissions for this course work are due. This must be specified if `due_date` is specified.\n*   `gradeCategory` (*type:* `GoogleApi.Classroom.V1.Model.GradeCategory.t`, *default:* `nil`) - The category that this coursework's grade contributes to. Present only when a category has been chosen for the coursework. May be used in calculating the overall grade. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Classroom-assigned identifier of this course work, unique per course. Read-only.\n*   `individualStudentsOptions` (*type:* `GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.t`, *default:* `nil`) - Identifiers of students with access to the coursework. This field is set only if `assigneeMode` is `INDIVIDUAL_STUDENTS`. If the `assigneeMode` is `INDIVIDUAL_STUDENTS`, then only students specified in this field are assigned the coursework.\n*   `materials` (*type:* `list(GoogleApi.Classroom.V1.Model.Material.t)`, *default:* `nil`) - Additional materials. CourseWork must have no more than 20 material items.\n*   `maxPoints` (*type:* `float()`, *default:* `nil`) - Maximum grade for this course work. If zero or unspecified, this assignment is considered ungraded. This must be a non-negative integer value.\n*   `multipleChoiceQuestion` (*type:* `GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.t`, *default:* `nil`) - Multiple choice question details. For read operations, this field is populated only when `work_type` is `MULTIPLE_CHOICE_QUESTION`. For write operations, this field must be specified when creating course work with a `work_type` of `MULTIPLE_CHOICE_QUESTION`, and it must not be set otherwise.\n*   `scheduledTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional timestamp when this course work is scheduled to be published.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Status of this course work. If unspecified, the default state is `DRAFT`.\n*   `submissionModificationMode` (*type:* `String.t`, *default:* `nil`) - Setting to determine when students are allowed to modify submissions. If unspecified, the default value is `MODIFIABLE_UNTIL_TURNED_IN`.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of this course work. The title must be a valid UTF-8 string containing between 1 and 3000 characters.\n*   `topicId` (*type:* `String.t`, *default:* `nil`) - Identifier for the topic that this coursework is associated with. Must match an existing topic in the course.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp of the most recent change to this course work. Read-only.\n*   `workType` (*type:* `String.t`, *default:* `nil`) - Type of this course work. The type is set when the course work is created and cannot be changed.","ref":"GoogleApi.Classroom.V1.Model.CourseWork.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseWork.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseWork.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseWork.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseWork.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo","doc":"Information about a `Feed` with a `feed_type` of `COURSE_WORK_CHANGES`.","ref":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - The `course_id` of the course to subscribe to work changes for.","ref":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial","doc":"Course work material created by a teacher for students of the course","ref":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.CourseWorkMaterial","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - Absolute link to this course work material in the Classroom web UI. This is only populated if `state` is `PUBLISHED`. Read-only.\n*   `assigneeMode` (*type:* `String.t`, *default:* `nil`) - Assignee mode of the course work material. If unspecified, the default value is `ALL_STUDENTS`.\n*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp when this course work material was created. Read-only.\n*   `creatorUserId` (*type:* `String.t`, *default:* `nil`) - Identifier for the user that created the course work material. Read-only.\n*   `description` (*type:* `String.t`, *default:* `nil`) - Optional description of this course work material. The text must be a valid UTF-8 string containing no more than 30,000 characters.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Classroom-assigned identifier of this course work material, unique per course. Read-only.\n*   `individualStudentsOptions` (*type:* `GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.t`, *default:* `nil`) - Identifiers of students with access to the course work material. This field is set only if `assigneeMode` is `INDIVIDUAL_STUDENTS`. If the `assigneeMode` is `INDIVIDUAL_STUDENTS`, then only students specified in this field can see the course work material.\n*   `materials` (*type:* `list(GoogleApi.Classroom.V1.Model.Material.t)`, *default:* `nil`) - Additional materials. A course work material must have no more than 20 material items.\n*   `scheduledTime` (*type:* `DateTime.t`, *default:* `nil`) - Optional timestamp when this course work material is scheduled to be published.\n*   `state` (*type:* `String.t`, *default:* `nil`) - Status of this course work material. If unspecified, the default state is `DRAFT`.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of this course work material. The title must be a valid UTF-8 string containing between 1 and 3000 characters.\n*   `topicId` (*type:* `String.t`, *default:* `nil`) - Identifier for the topic that this course work material is associated with. Must match an existing topic in the course.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Timestamp of the most recent change to this course work material. Read-only.","ref":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.CourseWorkMaterial.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Criterion","doc":"A rubric criterion. Each criterion is a dimension on which performance is rated.","ref":"GoogleApi.Classroom.V1.Model.Criterion.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Criterion","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - The description of the criterion.\n*   `id` (*type:* `String.t`, *default:* `nil`) - The criterion ID. On creation, an ID is assigned.\n*   `levels` (*type:* `list(GoogleApi.Classroom.V1.Model.Level.t)`, *default:* `nil`) - The list of levels within this criterion.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The title of the criterion.","ref":"GoogleApi.Classroom.V1.Model.Criterion.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Criterion.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Criterion.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Criterion.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Criterion.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Date","doc":"Represents a whole or partial calendar date, such as a birthday. The time of day and time zone are either specified elsewhere or are insignificant. The date is relative to the Gregorian Calendar. This can represent one of the following: * A full date, with non-zero year, month, and day values. * A month and day, with a zero year (for example, an anniversary). * A year on its own, with a zero month and a zero day. * A year and month, with a zero day (for example, a credit card expiration date). Related types: * google.type.TimeOfDay * google.type.DateTime * google.protobuf.Timestamp","ref":"GoogleApi.Classroom.V1.Model.Date.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Date","doc":"*   `day` (*type:* `integer()`, *default:* `nil`) - Day of a month. Must be from 1 to 31 and valid for the year and month, or 0 to specify a year by itself or a year and month where the day isn't significant.\n*   `month` (*type:* `integer()`, *default:* `nil`) - Month of a year. Must be from 1 to 12, or 0 to specify a year without a month and day.\n*   `year` (*type:* `integer()`, *default:* `nil`) - Year of the date. Must be from 1 to 9999, or 0 to specify a date without a year.","ref":"GoogleApi.Classroom.V1.Model.Date.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Date.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Date.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Date.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Date.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.DriveFile","doc":"Representation of a Google Drive file.","ref":"GoogleApi.Classroom.V1.Model.DriveFile.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.DriveFile","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - URL that can be used to access the Drive item. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Drive API resource ID.\n*   `thumbnailUrl` (*type:* `String.t`, *default:* `nil`) - URL of a thumbnail image of the Drive item. Read-only.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of the Drive item. Read-only.","ref":"GoogleApi.Classroom.V1.Model.DriveFile.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.DriveFile.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.DriveFile.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.DriveFile.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.DriveFile.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.DriveFolder","doc":"Representation of a Google Drive folder.","ref":"GoogleApi.Classroom.V1.Model.DriveFolder.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.DriveFolder","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - URL that can be used to access the Drive folder. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Drive API resource ID.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of the Drive folder. Read-only.","ref":"GoogleApi.Classroom.V1.Model.DriveFolder.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.DriveFolder.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.DriveFolder.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.DriveFolder.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.DriveFolder.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.EmbedUri","doc":"URI to be iframed after being populated with query parameters.","ref":"GoogleApi.Classroom.V1.Model.EmbedUri.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.EmbedUri","doc":"*   `uri` (*type:* `String.t`, *default:* `nil`) - Required. URI to be iframed after being populated with query parameters. This must be a valid UTF-8 string containing between 1 and 1800 characters.","ref":"GoogleApi.Classroom.V1.Model.EmbedUri.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.EmbedUri.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.EmbedUri.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.EmbedUri.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.EmbedUri.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Empty","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); }","ref":"GoogleApi.Classroom.V1.Model.Empty.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Empty","doc":"","ref":"GoogleApi.Classroom.V1.Model.Empty.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Empty.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Empty.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Empty.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Empty.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Feed","doc":"A class of notifications that an application can register to receive. For example: \"all roster changes for a domain\".","ref":"GoogleApi.Classroom.V1.Model.Feed.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Feed","doc":"*   `courseRosterChangesInfo` (*type:* `GoogleApi.Classroom.V1.Model.CourseRosterChangesInfo.t`, *default:* `nil`) - Information about a `Feed` with a `feed_type` of `COURSE_ROSTER_CHANGES`. This field must be specified if `feed_type` is `COURSE_ROSTER_CHANGES`.\n*   `courseWorkChangesInfo` (*type:* `GoogleApi.Classroom.V1.Model.CourseWorkChangesInfo.t`, *default:* `nil`) - Information about a `Feed` with a `feed_type` of `COURSE_WORK_CHANGES`. This field must be specified if `feed_type` is `COURSE_WORK_CHANGES`.\n*   `feedType` (*type:* `String.t`, *default:* `nil`) - The type of feed.","ref":"GoogleApi.Classroom.V1.Model.Feed.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Feed.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Feed.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Feed.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Feed.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Form","doc":"Google Forms item.","ref":"GoogleApi.Classroom.V1.Model.Form.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Form","doc":"*   `formUrl` (*type:* `String.t`, *default:* `nil`) - URL of the form.\n*   `responseUrl` (*type:* `String.t`, *default:* `nil`) - URL of the form responses document. Only set if responses have been recorded and only when the requesting user is an editor of the form. Read-only.\n*   `thumbnailUrl` (*type:* `String.t`, *default:* `nil`) - URL of a thumbnail image of the Form. Read-only.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of the Form. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Form.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Form.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Form.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Form.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Form.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.GlobalPermission","doc":"Global user permission description.","ref":"GoogleApi.Classroom.V1.Model.GlobalPermission.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.GlobalPermission","doc":"*   `permission` (*type:* `String.t`, *default:* `nil`) - Permission value.","ref":"GoogleApi.Classroom.V1.Model.GlobalPermission.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.GlobalPermission.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.GlobalPermission.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.GlobalPermission.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.GlobalPermission.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.GradeCategory","doc":"Details for a grade category in a course. Coursework may have zero or one grade category, and the category may be used in computing the overall grade. See the [help center article](https://support.google.com/edu/classroom/answer/9184995) for details.","ref":"GoogleApi.Classroom.V1.Model.GradeCategory.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.GradeCategory","doc":"*   `defaultGradeDenominator` (*type:* `integer()`, *default:* `nil`) - Default value of denominator. Only applicable when grade calculation type is TOTAL_POINTS.\n*   `id` (*type:* `String.t`, *default:* `nil`) - ID of the grade category.\n*   `name` (*type:* `String.t`, *default:* `nil`) - Name of the grade category.\n*   `weight` (*type:* `integer()`, *default:* `nil`) - The weight of the category average as part of overall average. A weight of 12.34% is represented as 123400 (100% is 1,000,000). The last two digits should always be zero since we use two decimal precision. Only applicable when grade calculation type is WEIGHTED_CATEGORIES.","ref":"GoogleApi.Classroom.V1.Model.GradeCategory.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.GradeCategory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.GradeCategory.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.GradeCategory.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.GradeCategory.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.GradeHistory","doc":"The history of each grade on this submission.","ref":"GoogleApi.Classroom.V1.Model.GradeHistory.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.GradeHistory","doc":"*   `actorUserId` (*type:* `String.t`, *default:* `nil`) - The teacher who made the grade change.\n*   `gradeChangeType` (*type:* `String.t`, *default:* `nil`) - The type of grade change at this time in the submission grade history.\n*   `gradeTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - When the grade of the submission was changed.\n*   `maxPoints` (*type:* `float()`, *default:* `nil`) - The denominator of the grade at this time in the submission grade history.\n*   `pointsEarned` (*type:* `float()`, *default:* `nil`) - The numerator of the grade at this time in the submission grade history.","ref":"GoogleApi.Classroom.V1.Model.GradeHistory.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.GradeHistory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.GradeHistory.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.GradeHistory.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.GradeHistory.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.GradebookSettings","doc":"The gradebook settings for a course. See the [help center article](https://support.google.com/edu/classroom/answer/9184995) for details.","ref":"GoogleApi.Classroom.V1.Model.GradebookSettings.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.GradebookSettings","doc":"*   `calculationType` (*type:* `String.t`, *default:* `nil`) - Indicates how the overall grade is calculated.\n*   `displaySetting` (*type:* `String.t`, *default:* `nil`) - Indicates who can see the overall grade..\n*   `gradeCategories` (*type:* `list(GoogleApi.Classroom.V1.Model.GradeCategory.t)`, *default:* `nil`) - Grade categories that are available for coursework in the course.","ref":"GoogleApi.Classroom.V1.Model.GradebookSettings.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.GradebookSettings.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.GradebookSettings.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.GradebookSettings.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.GradebookSettings.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Guardian","doc":"Association between a student and a guardian of that student. The guardian may receive information about the student's course work.","ref":"GoogleApi.Classroom.V1.Model.Guardian.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Guardian","doc":"*   `guardianId` (*type:* `String.t`, *default:* `nil`) - Identifier for the guardian.\n*   `guardianProfile` (*type:* `GoogleApi.Classroom.V1.Model.UserProfile.t`, *default:* `nil`) - User profile for the guardian.\n*   `invitedEmailAddress` (*type:* `String.t`, *default:* `nil`) - The email address to which the initial guardian invitation was sent. This field is only visible to domain administrators.\n*   `studentId` (*type:* `String.t`, *default:* `nil`) - Identifier for the student to whom the guardian relationship applies.","ref":"GoogleApi.Classroom.V1.Model.Guardian.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Guardian.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Guardian.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Guardian.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Guardian.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.GuardianInvitation","doc":"An invitation to become the guardian of a specified user, sent to a specified email address.","ref":"GoogleApi.Classroom.V1.Model.GuardianInvitation.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.GuardianInvitation","doc":"*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - The time that this invitation was created. Read-only.\n*   `invitationId` (*type:* `String.t`, *default:* `nil`) - Unique identifier for this invitation. Read-only.\n*   `invitedEmailAddress` (*type:* `String.t`, *default:* `nil`) - Email address that the invitation was sent to. This field is only visible to domain administrators.\n*   `state` (*type:* `String.t`, *default:* `nil`) - The state that this invitation is in.\n*   `studentId` (*type:* `String.t`, *default:* `nil`) - ID of the student (in standard format)","ref":"GoogleApi.Classroom.V1.Model.GuardianInvitation.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.GuardianInvitation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.GuardianInvitation.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.GuardianInvitation.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.GuardianInvitation.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions","doc":"Assignee details about a coursework/announcement. This field is set if and only if `assigneeMode` is `INDIVIDUAL_STUDENTS`.","ref":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.IndividualStudentsOptions","doc":"*   `studentIds` (*type:* `list(String.t)`, *default:* `nil`) - Identifiers for the students that have access to the coursework/announcement.","ref":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.IndividualStudentsOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Invitation","doc":"An invitation to join a course.","ref":"GoogleApi.Classroom.V1.Model.Invitation.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Invitation","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course to invite the user to.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Identifier assigned by Classroom. Read-only.\n*   `role` (*type:* `String.t`, *default:* `nil`) - Role to invite the user to have. Must not be `COURSE_ROLE_UNSPECIFIED`.\n*   `userId` (*type:* `String.t`, *default:* `nil`) - Identifier of the invited user. When specified as a parameter of a request, this identifier can be set to one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user","ref":"GoogleApi.Classroom.V1.Model.Invitation.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Invitation.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Invitation.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Invitation.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Invitation.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Level","doc":"A level of the criterion.","ref":"GoogleApi.Classroom.V1.Model.Level.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Level","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - The description of the level.\n*   `id` (*type:* `String.t`, *default:* `nil`) - The level ID. On creation, an ID is assigned.\n*   `points` (*type:* `float()`, *default:* `nil`) - Optional points associated with this level. If set, all levels within the rubric must specify points and the value must be distinct across all levels within a single criterion. 0 is distinct from no points.\n*   `title` (*type:* `String.t`, *default:* `nil`) - The title of the level. If the level has no points set, title must be set.","ref":"GoogleApi.Classroom.V1.Model.Level.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Level.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Level.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Level.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Level.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Link","doc":"URL item.","ref":"GoogleApi.Classroom.V1.Model.Link.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Link","doc":"*   `thumbnailUrl` (*type:* `String.t`, *default:* `nil`) - URL of a thumbnail image of the target URL. Read-only.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of the target of the URL. Read-only.\n*   `url` (*type:* `String.t`, *default:* `nil`) - URL to link to. This must be a valid UTF-8 string containing between 1 and 2024 characters.","ref":"GoogleApi.Classroom.V1.Model.Link.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Link.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Link.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Link.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Link.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse","doc":"Response when listing add-on attachments.","ref":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse","doc":"*   `addOnAttachments` (*type:* `list(GoogleApi.Classroom.V1.Model.AddOnAttachment.t)`, *default:* `nil`) - Attachments under the given post.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - A token, which can be sent as `pageToken` to retrieve the next page. If this field is omitted, there are no subsequent pages.","ref":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListAddOnAttachmentsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse","doc":"Response when listing course work.","ref":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse","doc":"*   `announcements` (*type:* `list(GoogleApi.Classroom.V1.Model.Announcement.t)`, *default:* `nil`) - Announcement items that match the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListAnnouncementsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse","doc":"Response when listing course aliases.","ref":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse","doc":"*   `aliases` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseAlias.t)`, *default:* `nil`) - The course aliases.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListCourseAliasesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse","doc":"Response when listing course work material.","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse","doc":"*   `courseWorkMaterial` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseWorkMaterial.t)`, *default:* `nil`) - Course work material items that match the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkMaterialResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse","doc":"Response when listing course work.","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListCourseWorkResponse","doc":"*   `courseWork` (*type:* `list(GoogleApi.Classroom.V1.Model.CourseWork.t)`, *default:* `nil`) - Course work items that match the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListCourseWorkResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListCoursesResponse","doc":"Response when listing courses.","ref":"GoogleApi.Classroom.V1.Model.ListCoursesResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListCoursesResponse","doc":"*   `courses` (*type:* `list(GoogleApi.Classroom.V1.Model.Course.t)`, *default:* `nil`) - Courses that match the list request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListCoursesResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListCoursesResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListCoursesResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListCoursesResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListCoursesResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse","doc":"Response when listing guardian invitations.","ref":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse","doc":"*   `guardianInvitations` (*type:* `list(GoogleApi.Classroom.V1.Model.GuardianInvitation.t)`, *default:* `nil`) - Guardian invitations that matched the list request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListGuardianInvitationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse","doc":"Response when listing guardians.","ref":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListGuardiansResponse","doc":"*   `guardians` (*type:* `list(GoogleApi.Classroom.V1.Model.Guardian.t)`, *default:* `nil`) - Guardians on this page of results that met the criteria specified in the request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListGuardiansResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse","doc":"Response when listing invitations.","ref":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListInvitationsResponse","doc":"*   `invitations` (*type:* `list(GoogleApi.Classroom.V1.Model.Invitation.t)`, *default:* `nil`) - Invitations that match the list request.\n*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.","ref":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListInvitationsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListRubricsResponse","doc":"Response when listing rubrics.","ref":"GoogleApi.Classroom.V1.Model.ListRubricsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListRubricsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.\n*   `rubrics` (*type:* `list(GoogleApi.Classroom.V1.Model.Rubric.t)`, *default:* `nil`) - Rubrics that match the request.","ref":"GoogleApi.Classroom.V1.Model.ListRubricsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListRubricsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListRubricsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListRubricsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListRubricsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse","doc":"Response when listing student submissions.","ref":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.\n*   `studentSubmissions` (*type:* `list(GoogleApi.Classroom.V1.Model.StudentSubmission.t)`, *default:* `nil`) - Student work that matches the request.","ref":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListStudentSubmissionsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListStudentsResponse","doc":"Response when listing students.","ref":"GoogleApi.Classroom.V1.Model.ListStudentsResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListStudentsResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.\n*   `students` (*type:* `list(GoogleApi.Classroom.V1.Model.Student.t)`, *default:* `nil`) - Students who match the list request.","ref":"GoogleApi.Classroom.V1.Model.ListStudentsResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListStudentsResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListStudentsResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListStudentsResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListStudentsResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListTeachersResponse","doc":"Response when listing teachers.","ref":"GoogleApi.Classroom.V1.Model.ListTeachersResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListTeachersResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.\n*   `teachers` (*type:* `list(GoogleApi.Classroom.V1.Model.Teacher.t)`, *default:* `nil`) - Teachers who match the list request.","ref":"GoogleApi.Classroom.V1.Model.ListTeachersResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListTeachersResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListTeachersResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListTeachersResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListTeachersResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ListTopicResponse","doc":"Response when listing topics.","ref":"GoogleApi.Classroom.V1.Model.ListTopicResponse.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ListTopicResponse","doc":"*   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Token identifying the next page of results to return. If empty, no further results are available.\n*   `topic` (*type:* `list(GoogleApi.Classroom.V1.Model.Topic.t)`, *default:* `nil`) - Topic items that match the request.","ref":"GoogleApi.Classroom.V1.Model.ListTopicResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ListTopicResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ListTopicResponse.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ListTopicResponse.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ListTopicResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Material","doc":"Material attached to course work. When creating attachments, setting the `form` field is not supported.","ref":"GoogleApi.Classroom.V1.Model.Material.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Material","doc":"*   `driveFile` (*type:* `GoogleApi.Classroom.V1.Model.SharedDriveFile.t`, *default:* `nil`) - Google Drive file material.\n*   `form` (*type:* `GoogleApi.Classroom.V1.Model.Form.t`, *default:* `nil`) - Google Forms material.\n*   `link` (*type:* `GoogleApi.Classroom.V1.Model.Link.t`, *default:* `nil`) - Link material. On creation, this is upgraded to a more appropriate type if possible, and this is reflected in the response.\n*   `youtubeVideo` (*type:* `GoogleApi.Classroom.V1.Model.YouTubeVideo.t`, *default:* `nil`) - YouTube video material.","ref":"GoogleApi.Classroom.V1.Model.Material.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Material.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Material.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Material.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Material.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest","doc":"Request to modify assignee mode and options of an announcement.","ref":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest","doc":"*   `assigneeMode` (*type:* `String.t`, *default:* `nil`) - Mode of the announcement describing whether it is accessible by all students or specified individual students.\n*   `modifyIndividualStudentsOptions` (*type:* `GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.t`, *default:* `nil`) - Set which students can view or cannot view the announcement. Must be specified only when `assigneeMode` is `INDIVIDUAL_STUDENTS`.","ref":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ModifyAnnouncementAssigneesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest","doc":"Request to modify the attachments of a student submission.","ref":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest","doc":"*   `addAttachments` (*type:* `list(GoogleApi.Classroom.V1.Model.Attachment.t)`, *default:* `nil`) - Attachments to add. A student submission may not have more than 20 attachments. Form attachments are not supported.","ref":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ModifyAttachmentsRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest","doc":"Request to modify assignee mode and options of a coursework.","ref":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest","doc":"*   `assigneeMode` (*type:* `String.t`, *default:* `nil`) - Mode of the coursework describing whether it will be assigned to all students or specified individual students.\n*   `modifyIndividualStudentsOptions` (*type:* `GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.t`, *default:* `nil`) - Set which students are assigned or not assigned to the coursework. Must be specified only when `assigneeMode` is `INDIVIDUAL_STUDENTS`.","ref":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ModifyCourseWorkAssigneesRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions","doc":"Contains fields to add or remove students from a course work or announcement where the `assigneeMode` is set to `INDIVIDUAL_STUDENTS`.","ref":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions","doc":"*   `addStudentIds` (*type:* `list(String.t)`, *default:* `nil`) - IDs of students to be added as having access to this coursework/announcement.\n*   `removeStudentIds` (*type:* `list(String.t)`, *default:* `nil`) - IDs of students to be removed from having access to this coursework/announcement.","ref":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ModifyIndividualStudentsOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion","doc":"Additional details for multiple-choice questions.","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion","doc":"*   `choices` (*type:* `list(String.t)`, *default:* `nil`) - Possible choices.","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceQuestion.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission","doc":"Student work for a multiple-choice question.","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission","doc":"*   `answer` (*type:* `String.t`, *default:* `nil`) - Student's select choice.","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Name","doc":"Details of the user's name.","ref":"GoogleApi.Classroom.V1.Model.Name.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Name","doc":"*   `familyName` (*type:* `String.t`, *default:* `nil`) - The user's last name. Read-only.\n*   `fullName` (*type:* `String.t`, *default:* `nil`) - The user's full name formed by concatenating the first and last name values. Read-only.\n*   `givenName` (*type:* `String.t`, *default:* `nil`) - The user's first name. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Name.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Name.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Name.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Name.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Name.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest","doc":"Request to reclaim a student submission.","ref":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest","doc":"","ref":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ReclaimStudentSubmissionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Registration","doc":"An instruction to Classroom to send notifications from the `feed` to the provided destination.","ref":"GoogleApi.Classroom.V1.Model.Registration.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Registration","doc":"*   `cloudPubsubTopic` (*type:* `GoogleApi.Classroom.V1.Model.CloudPubsubTopic.t`, *default:* `nil`) - The Cloud Pub/Sub topic that notifications are to be sent to.\n*   `expiryTime` (*type:* `DateTime.t`, *default:* `nil`) - The time until which the `Registration` is effective. This is a read-only field assigned by the server.\n*   `feed` (*type:* `GoogleApi.Classroom.V1.Model.Feed.t`, *default:* `nil`) - Specification for the class of notifications that Classroom should deliver to the destination.\n*   `registrationId` (*type:* `String.t`, *default:* `nil`) - A server-generated unique identifier for this `Registration`. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Registration.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Registration.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Registration.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Registration.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Registration.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest","doc":"Request to return a student submission.","ref":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest","doc":"","ref":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ReturnStudentSubmissionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Rubric","doc":"The rubric of the course work. A rubric is a scoring guide used to evaluate student work and give feedback. For further details, see [Rubrics structure and known limitations](/classroom/rubrics/limitations).","ref":"GoogleApi.Classroom.V1.Model.Rubric.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Rubric","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `courseWorkId` (*type:* `String.t`, *default:* `nil`) - Identifier for the course work this corresponds to. Read-only.\n*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Timestamp when this rubric was created. Read-only.\n*   `criteria` (*type:* `list(GoogleApi.Classroom.V1.Model.Criterion.t)`, *default:* `nil`) - List of criteria. Each criterion is a dimension on which performance is rated.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Classroom-assigned identifier for the rubric. This is unique among rubrics for the relevant course work. Read-only.\n*   `sourceSpreadsheetId` (*type:* `String.t`, *default:* `nil`) - Input only. Immutable. Google Sheets ID of the spreadsheet. This spreadsheet must contain formatted rubric settings. See [Create or reuse a rubric for an assignment](https://support.google.com/edu/classroom/answer/9335069). Use of this field requires the `https://www.googleapis.com/auth/spreadsheets.readonly` or `https://www.googleapis.com/auth/spreadsheets` scope.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. Timestamp of the most recent change to this rubric. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Rubric.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Rubric.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Rubric.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Rubric.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Rubric.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.RubricGrade","doc":"A rubric grade set for the student submission. There is at most one entry per rubric criterion.","ref":"GoogleApi.Classroom.V1.Model.RubricGrade.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.RubricGrade","doc":"*   `criterionId` (*type:* `String.t`, *default:* `nil`) - Optional. Criterion ID.\n*   `levelId` (*type:* `String.t`, *default:* `nil`) - Optional. Optional level ID of the selected level. If empty, no level was selected.\n*   `points` (*type:* `float()`, *default:* `nil`) - Optional. Optional points assigned for this criterion, typically based on the level. Levels might or might not have points. If unset, no points were set for this criterion.","ref":"GoogleApi.Classroom.V1.Model.RubricGrade.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.RubricGrade.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.RubricGrade.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.RubricGrade.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.RubricGrade.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.SharedDriveFile","doc":"Drive file that is used as material for course work.","ref":"GoogleApi.Classroom.V1.Model.SharedDriveFile.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.SharedDriveFile","doc":"*   `driveFile` (*type:* `GoogleApi.Classroom.V1.Model.DriveFile.t`, *default:* `nil`) - Drive file details.\n*   `shareMode` (*type:* `String.t`, *default:* `nil`) - Mechanism by which students access the Drive item.","ref":"GoogleApi.Classroom.V1.Model.SharedDriveFile.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.SharedDriveFile.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.SharedDriveFile.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.SharedDriveFile.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.SharedDriveFile.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission","doc":"Student work for a short answer question.","ref":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.ShortAnswerSubmission","doc":"*   `answer` (*type:* `String.t`, *default:* `nil`) - Student response to a short-answer question.","ref":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.StateHistory","doc":"The history of each state this submission has been in.","ref":"GoogleApi.Classroom.V1.Model.StateHistory.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.StateHistory","doc":"*   `actorUserId` (*type:* `String.t`, *default:* `nil`) - The teacher or student who made the change.\n*   `state` (*type:* `String.t`, *default:* `nil`) - The workflow pipeline stage.\n*   `stateTimestamp` (*type:* `DateTime.t`, *default:* `nil`) - When the submission entered this state.","ref":"GoogleApi.Classroom.V1.Model.StateHistory.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.StateHistory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.StateHistory.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.StateHistory.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.StateHistory.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Student","doc":"Student in a course.","ref":"GoogleApi.Classroom.V1.Model.Student.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Student","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `profile` (*type:* `GoogleApi.Classroom.V1.Model.UserProfile.t`, *default:* `nil`) - Global user information for the student. Read-only.\n*   `studentWorkFolder` (*type:* `GoogleApi.Classroom.V1.Model.DriveFolder.t`, *default:* `nil`) - Information about a Drive Folder for this student's work in this course. Only visible to the student and domain administrators. Read-only.\n*   `userId` (*type:* `String.t`, *default:* `nil`) - Identifier of the user. When specified as a parameter of a request, this identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user","ref":"GoogleApi.Classroom.V1.Model.Student.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Student.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Student.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Student.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Student.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.StudentContext","doc":"Role-specific context if the requesting user is a student.","ref":"GoogleApi.Classroom.V1.Model.StudentContext.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.StudentContext","doc":"*   `submissionId` (*type:* `String.t`, *default:* `nil`) - Requesting user's submission id to be used for grade passback and to identify the student when showing student work to the teacher. This is set exactly when `supportsStudentWork` is `true`.","ref":"GoogleApi.Classroom.V1.Model.StudentContext.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.StudentContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.StudentContext.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.StudentContext.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.StudentContext.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.StudentSubmission","doc":"Student submission for course work. `StudentSubmission` items are generated when a `CourseWork` item is created. Student submissions that have never been accessed (i.e. with `state` = NEW) may not have a creation time or update time.","ref":"GoogleApi.Classroom.V1.Model.StudentSubmission.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.StudentSubmission","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - Absolute link to the submission in the Classroom web UI. Read-only.\n*   `assignedGrade` (*type:* `float()`, *default:* `nil`) - Optional grade. If unset, no grade was set. This value must be non-negative. Decimal (that is, non-integer) values are allowed, but are rounded to two decimal places. This may be modified only by course teachers.\n*   `assignedRubricGrades` (*type:* `%{optional(String.t) => GoogleApi.Classroom.V1.Model.RubricGrade.t}`, *default:* `nil`) - Assigned rubric grades based on the rubric's Criteria. This map is empty if there is no rubric attached to this course work or if a rubric is attached, but no grades have been set on any Criteria. Entries are only populated for grades that have been set. Key: The rubric's criterion ID. Read-only.\n*   `assignmentSubmission` (*type:* `GoogleApi.Classroom.V1.Model.AssignmentSubmission.t`, *default:* `nil`) - Submission content when course_work_type is ASSIGNMENT. Students can modify this content using ModifyAttachments.\n*   `associatedWithDeveloper` (*type:* `boolean()`, *default:* `nil`) - Whether this student submission is associated with the Developer Console project making the request. See CreateCourseWork for more details. Read-only.\n*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `courseWorkId` (*type:* `String.t`, *default:* `nil`) - Identifier for the course work this corresponds to. Read-only.\n*   `courseWorkType` (*type:* `String.t`, *default:* `nil`) - Type of course work this submission is for. Read-only.\n*   `creationTime` (*type:* `DateTime.t`, *default:* `nil`) - Creation time of this submission. This may be unset if the student has not accessed this item. Read-only.\n*   `draftGrade` (*type:* `float()`, *default:* `nil`) - Optional pending grade. If unset, no grade was set. This value must be non-negative. Decimal (that is, non-integer) values are allowed, but are rounded to two decimal places. This is only visible to and modifiable by course teachers.\n*   `draftRubricGrades` (*type:* `%{optional(String.t) => GoogleApi.Classroom.V1.Model.RubricGrade.t}`, *default:* `nil`) - Pending rubric grades based on the rubric's criteria. This map is empty if there is no rubric attached to this course work or if a rubric is attached, but no grades have been set on any criteria. Entries are only populated for grades that have been set. Key: The rubric's criterion ID. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Classroom-assigned Identifier for the student submission. This is unique among submissions for the relevant course work. Read-only.\n*   `late` (*type:* `boolean()`, *default:* `nil`) - Whether this submission is late. Read-only.\n*   `multipleChoiceSubmission` (*type:* `GoogleApi.Classroom.V1.Model.MultipleChoiceSubmission.t`, *default:* `nil`) - Submission content when course_work_type is MULTIPLE_CHOICE_QUESTION.\n*   `shortAnswerSubmission` (*type:* `GoogleApi.Classroom.V1.Model.ShortAnswerSubmission.t`, *default:* `nil`) - Submission content when course_work_type is SHORT_ANSWER_QUESTION.\n*   `state` (*type:* `String.t`, *default:* `nil`) - State of this submission. Read-only.\n*   `submissionHistory` (*type:* `list(GoogleApi.Classroom.V1.Model.SubmissionHistory.t)`, *default:* `nil`) - The history of the submission (includes state and grade histories). Read-only.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - Last update time of this submission. This may be unset if the student has not accessed this item. Read-only.\n*   `userId` (*type:* `String.t`, *default:* `nil`) - Identifier for the student that owns this submission. Read-only.","ref":"GoogleApi.Classroom.V1.Model.StudentSubmission.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.StudentSubmission.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.StudentSubmission.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.StudentSubmission.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.StudentSubmission.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.SubmissionHistory","doc":"The history of the submission. This currently includes state and grade histories.","ref":"GoogleApi.Classroom.V1.Model.SubmissionHistory.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.SubmissionHistory","doc":"*   `gradeHistory` (*type:* `GoogleApi.Classroom.V1.Model.GradeHistory.t`, *default:* `nil`) - The grade history information of the submission, if present.\n*   `stateHistory` (*type:* `GoogleApi.Classroom.V1.Model.StateHistory.t`, *default:* `nil`) - The state history information of the submission, if present.","ref":"GoogleApi.Classroom.V1.Model.SubmissionHistory.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.SubmissionHistory.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.SubmissionHistory.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.SubmissionHistory.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.SubmissionHistory.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Teacher","doc":"Teacher of a course.","ref":"GoogleApi.Classroom.V1.Model.Teacher.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Teacher","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `profile` (*type:* `GoogleApi.Classroom.V1.Model.UserProfile.t`, *default:* `nil`) - Global user information for the teacher. Read-only.\n*   `userId` (*type:* `String.t`, *default:* `nil`) - Identifier of the user. When specified as a parameter of a request, this identifier can be one of the following: * the numeric identifier for the user * the email address of the user * the string literal `\"me\"`, indicating the requesting user","ref":"GoogleApi.Classroom.V1.Model.Teacher.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Teacher.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Teacher.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Teacher.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Teacher.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.TeacherContext","doc":"Role-specific context if the requesting user is a teacher.","ref":"GoogleApi.Classroom.V1.Model.TeacherContext.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.TeacherContext","doc":"","ref":"GoogleApi.Classroom.V1.Model.TeacherContext.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.TeacherContext.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.TeacherContext.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.TeacherContext.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.TeacherContext.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.TimeOfDay","doc":"Represents a time of day. The date and time zone are either not significant or are specified elsewhere. An API may choose to allow leap seconds. Related types are google.type.Date and `google.protobuf.Timestamp`.","ref":"GoogleApi.Classroom.V1.Model.TimeOfDay.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.TimeOfDay","doc":"*   `hours` (*type:* `integer()`, *default:* `nil`) - Hours of a day in 24 hour format. Must be greater than or equal to 0 and typically must be less than or equal to 23. An API may choose to allow the value \"24:00:00\" for scenarios like business closing time.\n*   `minutes` (*type:* `integer()`, *default:* `nil`) - Minutes of an hour. Must be greater than or equal to 0 and less than or equal to 59.\n*   `nanos` (*type:* `integer()`, *default:* `nil`) - Fractions of seconds, in nanoseconds. Must be greater than or equal to 0 and less than or equal to 999,999,999.\n*   `seconds` (*type:* `integer()`, *default:* `nil`) - Seconds of a minute. Must be greater than or equal to 0 and typically must be less than or equal to 59. An API may allow the value 60 if it allows leap-seconds.","ref":"GoogleApi.Classroom.V1.Model.TimeOfDay.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.TimeOfDay.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.TimeOfDay.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.TimeOfDay.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.TimeOfDay.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.Topic","doc":"Topic created by a teacher for the course","ref":"GoogleApi.Classroom.V1.Model.Topic.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.Topic","doc":"*   `courseId` (*type:* `String.t`, *default:* `nil`) - Identifier of the course. Read-only.\n*   `name` (*type:* `String.t`, *default:* `nil`) - The name of the topic, generated by the user. Leading and trailing whitespaces, if any, are trimmed. Also, multiple consecutive whitespaces are collapsed into one inside the name. The result must be a non-empty string. Topic names are case sensitive, and must be no longer than 100 characters.\n*   `topicId` (*type:* `String.t`, *default:* `nil`) - Unique identifier for the topic. Read-only.\n*   `updateTime` (*type:* `DateTime.t`, *default:* `nil`) - The time the topic was last updated by the system. Read-only.","ref":"GoogleApi.Classroom.V1.Model.Topic.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.Topic.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.Topic.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.Topic.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.Topic.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest","doc":"Request to turn in a student submission.","ref":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest","doc":"","ref":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.TurnInStudentSubmissionRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.UserProfile","doc":"Global information for a user.","ref":"GoogleApi.Classroom.V1.Model.UserProfile.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.UserProfile","doc":"*   `emailAddress` (*type:* `String.t`, *default:* `nil`) - Email address of the user. Must request `https://www.googleapis.com/auth/classroom.profile.emails` scope for this field to be populated in a response body. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - Identifier of the user. Read-only.\n*   `name` (*type:* `GoogleApi.Classroom.V1.Model.Name.t`, *default:* `nil`) - Name of the user. Read-only.\n*   `permissions` (*type:* `list(GoogleApi.Classroom.V1.Model.GlobalPermission.t)`, *default:* `nil`) - Global permissions of the user. Read-only.\n*   `photoUrl` (*type:* `String.t`, *default:* `nil`) - URL of user's profile photo. Must request `https://www.googleapis.com/auth/classroom.profile.photos` scope for this field to be populated in a response body. Read-only.\n*   `verifiedTeacher` (*type:* `boolean()`, *default:* `nil`) - Represents whether a Google Workspace for Education user's domain administrator has explicitly verified them as being a teacher. This field is always false if the user is not a member of a Google Workspace for Education domain. Read-only","ref":"GoogleApi.Classroom.V1.Model.UserProfile.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.UserProfile.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.UserProfile.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.UserProfile.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.UserProfile.html#t:t/0"},{"type":"module","title":"GoogleApi.Classroom.V1.Model.YouTubeVideo","doc":"YouTube video item.","ref":"GoogleApi.Classroom.V1.Model.YouTubeVideo.html"},{"type":"module","title":"Attributes - GoogleApi.Classroom.V1.Model.YouTubeVideo","doc":"*   `alternateLink` (*type:* `String.t`, *default:* `nil`) - URL that can be used to view the YouTube video. Read-only.\n*   `id` (*type:* `String.t`, *default:* `nil`) - YouTube API resource ID.\n*   `thumbnailUrl` (*type:* `String.t`, *default:* `nil`) - URL of a thumbnail image of the YouTube video. Read-only.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Title of the YouTube video. Read-only.","ref":"GoogleApi.Classroom.V1.Model.YouTubeVideo.html#module-attributes"},{"type":"function","title":"GoogleApi.Classroom.V1.Model.YouTubeVideo.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.Classroom.V1.Model.YouTubeVideo.html#decode/2"},{"type":"type","title":"GoogleApi.Classroom.V1.Model.YouTubeVideo.t/0","doc":"","ref":"GoogleApi.Classroom.V1.Model.YouTubeVideo.html#t:t/0"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.35.1"}}